***************************************************************
* Enviando emails e anexos                                    *
*                                                             *
* Desenvolvedor: Ricardo de Moura Marques                     *
* email: ricardomouramarques@hotmail.com                      *
*                                                             *
* Agradecimentos ao Alessandro Seribeli Barreto - "Ale SB"    *
* pelo cdigo inicial, sem o qual, esse projeto               *
* no seria possvel                                          *
* Modificado por: Joao Santos - 10/02/2011  Contato Sistemas  *
* Ultima Atualizacao: 24/02/2011  Por: Joao Santos            *
***************************************************************

#Include "FiveWin.ch"
#Include "BtnGet.Ch"
#Include "Report.Ch"          //-> Classe Para Reportes, Classe: C:\FWH\SOURCE\CLASSES\REPORT.PRG

#Define CLR_LGRAY     nRGB( 230, 230, 230 )
#Define CLR_LGREEN    nRGB( 190, 215, 190 )
#Define CLR_VERMELHO  nRGB( 255, 000, 000 ) //--> Vermelho Para a Letra
#Define CLR_AMARELO   nRGB( 255, 255, 000 ) //--> Amarelo Para o Fundo

REQUEST OrdKeyNo, OrdKeyCount, OrdCreate, OrdKeyGoto
 
STATIC cAttach := ""
STATIC aAttach := {}
STATIC oDlgIni, cTitleDial, oTimerRelog, oWnd // oDlg=Dados
STATIC oEnvia
STATIC aFiles
STATIC lLigaBotao := .F.
STATIC lRemoveGru := .T.
STATIC lExcluiServ:= .F.
STATIC lConsulta  := .T.
STATIC SER // ALIAS de: SERVIDOR.DBF
STATIC lAchoUsuario := .F. // Se tiver mais de um usuario na listbox

****************************************************************************

FUNCTION Main()

   //-> Campos(Fields) do Banco de Dados - SERVIDOR.DBF
   FIELD SEMAILPOP3, SEMAILSMTP, SEMAILCONT, NPORTASERV, CONEXAOSEG,  ;
         NOMEDOUSUA, SENHACONTA

   LOCAL nTop := 2, nLeft := 2, oBtn1
   LOCAL cUser := SPACE(50), cRemt := SPACE(50), ;
         cDest := SPACE(250), cTime, cTxt := SPACE(10), cAssunto := SPACE(100),;
                  cCC := SPACE(250), cCCO := SPACE(250)
   LOCAL oGet[8], oSay[12], oBtn[2], nItem := 0
   LOCAL cDados, i, oAdd, oDel, oFont, cTitle, oSay1, oTahoma, rCampo, oBrush
   LOCAL cServPOP3, cServSMTP, nServPORT, cServSEGU
   //-> Para checar o Tamanho do HD
   LOCAL nHandles := SetHandleCount( 150 ), oPlenoWin
  
   PRIVATE oCab, oGru, oCon, oCod, oMenu, lSair := .F., oM2, lCheck := .T.
   PRIVATE DbServidor, cNomeUsuario
   PRIVATE cPass := SPACE(15)

   // porta seguras: 110, 587, 995 - para o POP, somente com o discado deles. ADSL no funciona
   /* // Era assim - Mudei Para o Banco de Dados - funcionou legal
   PRIVATE aServs := { {"@hotmail.com",       "smtp.live.com",            25, .T. },;
                       {"@yahoo.com.br",      "smtp.mail.yahoo.com.br",   25, .F. },;
                       {"@silco.com.br",      "mail.silco.com.br",        25, .F. },;
                       {"@gmail.com",         "smtp.gmail.com",          465, .T. },;
                       {"@outlook.com.",      "smtp-mail.outlook.com",   465, .T. },;  // era hotmail.com
                       {"@uol.com.br",        "smtps.uol.com.br",        465, .T. },;
                       {"@bol.com.br",        "smtps.bol.com.br",        587, .F. },;  // mudou em: 06/08/2013-Marli-CGA.
                       {"@terra.com.br",      "smtp.terra.com.br",       465, .T. },;
                       {"@ig.com.br",         "smtp.ig.com.br",          465, .T. },;
                       {"@ibest.com.br",      "smtp.ibest.com.br",       465, .T. },;
                       {"@itelefonica.com.br","smtp.itelefonica.com.br",  25, .F. },;
                       {"@correio.pop.com.br","smtp.pop.com.br",          25, .F. },;
                       {"@cardim.com.br",     "smtp.cardim.com.br",      587, .F. },;
                       {"@parthenonassessoria.com.br", "smtp.parthenonassessoria.com.br", 587, .F. },;
                       {"@pleno.com.br",      "smtp.pleno.com.br",       587, .F. } }
   */

   // Esta area, pegar do banco de dados
   PRIVATE aServs  // Servidores
   PRIVATE aDomin := {}, nServ := 1 // Dominio e Servidores

   // Configuracoes do sistema
   SET DATE BRITISH
   SET CENTURY ON
   SET CONFIRM ON
   SET EPOCH TO YEAR(DATE())-50   // Liga a epoca
   SET DELETE ON
   SET EXCLUSIVE OFF // Verificar se vai manter abrindo em rede
   SETCANCEL( .F. )

   //-> Nao Permite Que o Usuario Acione Duas Vezes o Executavel.
   IF ISEXERUNNING( CFILENAME( HB_ARGV( 0 ) ) )
      __Quit()
   ENDIF

   IF nHandles < 150
      MsgStop( "Este Programa Necessita de Mais Recursos" +CHR(13)+ ;
               "Para Funcionar, Feche  Alguns  Programas" +CHR(13)+ ;
               "e Volte a Tentar Novamente.             ",          ;
               "Aviso Sobre a Execuo do Programa" )
      __QUIT()
   ENDIF

   //-------------------------Separador -----------------------------------//

   IF FILE( "dadosmail.dat" )

      cDados := StrTran(MemoRead( "dadosmail.dat" ), "@hotmail.com", "")
      cUser  := Memoline( cDados, 250, 1)
      cNomeUsuario := ALLTRIM( cUser ) // Nome do usuario para guardar
      cRemt  := Memoline( cDados, 250, 2)

      IF MlCount( cDados, 250 ) >= 3
         nServ := VAL(ALLTRIM(Memoline(cDados, 250, 3)))
      ENDIF

      IF MlCount( cDados, 250 ) >= 4

         IF ALLTRIM(ALLTRIM(Memoline(cDados, 250, 4))) = "0"
            lCheck := .F.
         ELSE
            lCheck := .T.
         ENDIF

      ENDIF

   ENDIF

   //-------------------------Separador -----------------------------------//

   // Criacao dos Bancos de Dados e Indices
   ArqsDBF() // Criacao e abertura dos DBFS
   ArqBmp()  // Cria uma BitMap, nao usei. Peguei direto do EMAIL.RES

   // Abertura do Banco de Dados dos Servidores, aqui.

   // Banco de dados dos Servidores de Email
   SELECT( DbServidor:cAlias )
   // SET INDEX TO SERVPOP3, SERVSMTP, NOMEUSUA
   SET INDEX TO NOMEUSUA  // Por nome do Usuario

   SER    := ALIAS() //-> ALIAS de: SERVIDOR.DBF
   SELECT( SER )
   DBGOTOP()

   SEEK cUser

   // Senha do Usuario - desemcryptada - moleza      secret
   rCampo := DECRYPT( ALLTRIM(( SER )->SENHACONTA ), "*+-." )
   cPass := ALLTRIM( rCampo ) // [kapiaba]

   // Configuracao do Servidor
   cServPOP3 :=  ALLTRIM( ( SER )->SEMAILPOP3 ) // Alfa
   cServSMTP :=  ALLTRIM( ( SER )->SEMAILSMTP ) // Alfa
   nServPORT :=         ( ( SER )->NPORTASERV ) // Numerico
   cServSEGU :=         ( ( SER )->CONEXAOSEG ) // Https/SSL? Servidor seguro? LOGICAL

   aServs := { { cServPop3, cServSMTP, nServPORT, cServSEGU } }

   // Pega o servidor
   FOR i := 1 to LEN( aServs )
      AADD( aDomin, aServs[i][1] )
   NEXT

   IF nServ = 0 .OR. nServ > LEN(aServs)
      nServ := 1
   ENDIF

   //-------------------------Separador -----------------------------------//

   // Dialogo e Titulo do Dialogo
   cTitleDial := OemToAnsi( "PLENOWIN - Envio de Email - Verso: 1.5" )

   DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine
   DEFINE FONT oFont1 NAME "Ms Sans Serif" SIZE 0, -12 BOLD
   DEFINE FONT oTahoma NAME "Tahoma"       SIZE 0, -12 BOLD // Para a senha

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   // ALT  LARG
   // 630, 600 "PLENOWIN - Envio de Email "
   DEFINE DIALOG oDlgIni                                   ;
          TITLE cTitleDial + " :: Hoje: " + DTOC( Date() ) ;
          FROM 0, 092 TO 535, 700 PIXEL BRUSH oBrush TRANSPARENT

   oDlgIni:lHelpIcon := .F.

   oDlgIni:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                            + CRLF+ ;
                                                "No Est Ativo" ), ;
                                   ( OemToAnsi( "Informao   " ) ) ) }

   //------------SAYS E GETS-----------------------------------------------//

   // Mensagem de Aguarde... no Botao de Enviar
   @ 235,006 SAY oSay[6] VAR cTime OF oDlgIni SIZE 90, 08 ;
             COLOR CLR_BLACK PIXEL UPDATE
 
   *****OUTROS*************************************************************

   *****--- SAY's ---********************************************************

   @ 012, 006 SAY oSay[1] PROMPT "<F7> Usurio                  "          ;
              OF oDlgIni SIZE 100, 08                                      ;
              COLOR CLR_BLACK PIXEL FONT oFont1

   @ 020, 006 BTNGET oGet[1] VAR cUser SIZE 80, 10 PIXEL                   ;
              OF oDlgIni PICTURE "@K"                                      ;
              UPDATE RESOURCE "BUSCAR"                                     ;
              VALID ( CHECA_GET_cUser( cUser, cNomeUsuario, oGet, oSay ) ) ;
              ACTION( CHECA_GET_cUser( cUser := SPACE(50), cNomeUsuario,   ;
                                       oGet, oSay ) )                      ;
              FONT oFont1

   oGet[1]:cToolTip := OemToAnsi( "Nome do Usurio Somente o Nome " + ;
                                  "No Use o @dominio.com.br      " )

   @ 042, 006 SAY oSay[4] PROMPT "Remetente                  " OF oDlgIni ;
              SIZE 100, 08 COLOR CLR_BLACK PIXEL FONT oFont1

   @ 050, 006 GET oGet[3] VAR cRemt SIZE 80, 10 PIXEL OF oDlgIni PICTURE "@" ;
              UPDATE      WHEN( .F. )  FONT oFont1

   // Nome do Dominio Tipo: @pleno.com.br
   @ 052, 088 SAY oSay[2] PROMPT aDomin[nServ] OF oDlgIni SIZE 100, 08 ;
              COLOR CLR_BLACK PIXEL FONT oFont1

   @ 062, 040 BTNGET oGet[4] VAR cDest SIZE 258, 09 PIXEL     ;
              OF oDlgIni PICTURE "@" UPDATE RESOURCE "BUSCAR" ;
              VALID( CHECA_GET_cDest( cDest ) )               ;
              ACTION INCLUI( oGet[4], @cDest )                ;
              FONT oFont1

   oGet[4]:cToolTip := OemToAnsi( "<F7> Busca o Contato(Email) " + ;
                                  "Campo Obrigatrio " )

   @ 072, 040 BTNGET oGet[5] VAR cCC SIZE 258, 09 PIXEL       ;
              OF oDlgIni PICTURE "@" UPDATE RESOURCE "BUSCAR" ;
              ACTION INCLUI( oGet[5], @cCC )                  ;
              FONT oFont1

   oGet[5]:cToolTip := OemToAnsi( "<F7> Busca o Contato(Email) " + ;
                                  "Para Enviar com Cpia " )

   @ 082, 040 BTNGET oGet[6] VAR cCCO SIZE 258, 09 PIXEL      ;
              OF oDlgIni PICTURE "@" UPDATE RESOURCE "BUSCAR" ;
              ACTION INCLUI( oGet[6], @cCCO )                 ;
              FONT oFont1

   oGet[6]:cToolTip := OemToAnsi( "<F7> Busca o Contato(Email) " + ;
                                  "Para Enviar com Cpia Oculta " )

   @ 094, 006 SAY oSay[9] VAR "Assunto...:   " OF oDlgIni SIZE 35, 09 ;
              COLOR CLR_BLACK PIXEL UPDATE RIGHT FONT oFont1

   @ 092, 040 BTNGET oGet[7] VAR cAssunto SIZE 258, 09 PIXEL ;
              OF oDlgIni PICTURE "@" UPDATE                  ;
              VALID( CHECA_GET_cAssunto( cAssunto ) )        ;
              FONT oFont1

   oGet[7]:cToolTip := OemToAnsi( "Assunto do Email Campo Obrigatrio " )

   @ 105,006 SAY oSay[7] VAR "Mensagem do Email: " OF oDlgIni SIZE 90, 08 ;
             COLOR CLR_BLACK PIXEL UPDATE FONT oFont1

   // Get da Mensagem - Cor: Branco no Preto //   288, 59
   @ 113,006 GET oGet[8] VAR cTxt OF oDlgIni SIZE 292, 59 ;
             COLOR CLR_BLACK, CLR_WHITE PIXEL UPDATE MEMO ;
             FONT oFont1

   oGet[8]:cToolTip := OemToAnsi( "Mensagem do Email Para o Destinatrio " )

   @ 176,006 SAY oSay[8] VAR "Anexos do Email: " OF oDlgIni SIZE 90, 08 ;
             COLOR CLR_BLACK PIXEL UPDATE FONT oFont1

   // anexos
   @ 184,006 ListBox oList Var nItem ITEMS aAttach SIZE 268, 50 PIXEL ;
             FONT oFont1 OF oDlgIni
 	 
   *****--- BOTOES ---*************************************************************

   @ 235, 099 BUTTONBMP oBtn[1] PROMPT "&Enviar Email " OF oDlgIni   ;
              SIZE 60, 12 PIXEL                                      ;
              ACTION ( cTime := "AGUARDE, TENTANDO ENVIAR.",         ;
                       oSay[6]:Refresh(),                            ;
                       IF( lRet := CONFIG_MAIL(LOWER(ALLTRIM(cUser)),;
                                               ALLTRIM(cPass),       ;
                                               LOWER(ALLTRIM(cRemt)),;
                                               LOWER(ALLTRIM(cDest)),;
                                               LOWER(ALLTRIM(cCC)),  ;
                                               LOWER(ALLTRIM(cCCO)), ;
                                               cTxt, cAssunto ),     ;
                       MsgInfo( "Mensagem Enviada com Sucesso! ",    ;
                                "Ateno "),), cTime := "",          ;
                                               oSay[6]:Refresh(),    ;
                                               XFOCUS( oGet[1] ) )

   oBtn[1]:cToolTip := OemToAnsi( "Enviar o Email ao Destinatrio " )

   oBtn[1]:bWhen := {|| !Empty(cUser) }

   SET FONT OF oBtn[1] TO oFont

   @ 240, 260 SAY oSay1 PROMPT( OemToAnsi( "<ESC> Sair  " ) )    ;
              SIZE 050, 12 OF oDlgIni                            ;
              PIXEL FONT oFont1 COLOR CLR_BLACK

   @ 235, 163 BUTTONBMP oBtn[2] PROMPT "&Saida "    OF oDlgIni ;
              SIZE 40, 12 PIXEL                             ;
              ACTION ( lSair := .T., oDlgIni:End() )CANCEL UPDATE

   oBtn[2]:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   oBtn[2]:lCancel := .T.

   SET FONT OF oBtn[2] TO oFont

   @ 173.00, 169 BUTTON oAdd PROMPT( "&Anexar " ) SIZE 50, 10 PIXEL ;
                 OF oDlgIni                                         ;
                 ACTION( ADDItem() )

   oAdd:cToolTip := OemToAnsi( "Adicionar(Inserir) Anexo(s) ao Email " )

   SET FONT OF oAdd TO oFont

   //-> Exclusao do Anexo - Modificado em: 10/02/2010
   @ 173.00, 223 BUTTON oDel PROMPT( "E&xcluir " ) SIZE 50, 10 PIXEL     ;
                 OF oDlgIni                                              ;
                 ACTION( IIF( LEN( aAttach ) >= 1, ( oList:Del( nItem ), ;
                                                     oList:Refresh() ),  ;
                              MsgInfo( "Sem Anexo(s) Para Excluir ",     ;
                                       "Aviso " ) ) )

   oDel:cToolTip := OemToAnsi( "Deletar(Apagar) Anexo(s) " )

   SET FONT OF oDel TO oFont

   // Para - Destinatario - BitMap cCom Texto
   @ 062, 006 BtnBmp oBt1 RESOURCE "BUSCAR" OF oDlgIni  ;
              PROMPT "Para:  "                          ;
              SIZE 32, 10 PIXEL RIGHT                   ;
              ACTION INCLUI( oGet[4], @cDest ) FONT oFont1

   oBt1:cToolTip := OemToAnsi( "<Click-me> Para Pegar Destinatrio " + ;
                               "<F7> Busca o Email " )

   @ 072, 006 BtnBmp oBt2 RESOURCE "BUSCAR" OF oDlgIni  ;
              PROMPT "CC:    "   SIZE 32,10 PIXEL RIGHT ;
              ACTION INCLUI( oGet[5], @cCC ) FONT oFont1

   oBt2:cToolTip := OemToAnsi( "<Click-me> Para Pegar o Contato(Email) "+;
                               "e Enviar com Cpia " )

   @ 082, 006 BtnBmp oBt3 RESOURCE "BUSCAR" OF oDlgIni ;
              PROMPT "CCO:  "  SIZE 32,10 PIXEL RIGHT  ;
              ACTION INCLUI( oGet[6], @cCCO ) FONT oFont1

   oBt3:cToolTip := OemToAnsi( "<Click-me> Para Pegar o Contato(Email) "+;
                               "e Enviar com Cpia Oculta " )

   @ 003, 265 BtnBmp oBtn1 RESOURCE "IEXPLORER_1" OF oDlgIni             ;
              SIZE 36, 36 NOBORDER CENTER                                ;
      ACTION( ( MsgRun( ( "Conectando a Pgina do PLENO.            " ), ;
                          "Conectando a Pgina do PELNO. Aguarde... ",   ;
                { || SITE_PLENOWIN() } ) ), XFOCUS( oGet[1] ) )                     ;
      CANCEL

   oBtn1:cToolTip := OemToAnsi( "Visite Site da Contato Sistemas" )

   ACTIVATE DIALOG oDlgIni                                          ;
            ON INIT( INICIO( oDlgIni ), ACIONA_TIMER( oWnd ) )      ;
            VALID ( FIM( cUser, cRemt, nServ ) )

   oBrush:End()
   oFont:End()
   oFont1:End()
   oTahoma:End()

   oTimerRelog:DeActivate()

   lLigaBotao   := .F.
   lRemoveGru   := .T.
   lExcluiServ  := .F.
   lConsulta    := .T.
   lAchoUsuario := .F.
 
RETURN NIL

STATIC FUNCTION CHECA_GET_cUser( ccUser, cNomeUsuario, oGet, oSay ) // Nome do Usuario - cUser

   LOCAL oFont, oFnt, iDcor, oBrush, oIco, oDlgSer, oLbxServ, cAlias
   LOCAL oConfirma, oSaida, lConfirma := .F., nRecNo
   LOCAL nKey := VK_RETURN

   LOCAL cServPOP3, cServSMTP, nServPORT, cServSEGU, rCampo, cPOP3

   IF GETASYNCKEY( VK_UP )
      RETURN( .F. )
   ENDIF

   IF lAchoUsuario .AND. ;
      ccUser != SPACE(50)
      RETURN( .T. )
   ENDIF

   // Banco de dados dos Servidores de Email
   SELECT( DbServidor:cAlias )
   // SET INDEX TO SERVPOP3, SERVSMTP, NOMEUSUA
   SET INDEX TO NOMEUSUA

   cAlias := ALIAS()
   // Para a Impressao ja peguei pronto de GASFW.EXE em C:\GASFW mantive
   SER    := ALIAS() //-> ALIAS de: SERVIDOR.DBF
   SELECT( SER )
   DBGOTOP()

   SEEK( LOWER( ccUser ) )

   IF FOUND()

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      cPass := SPACE(15)  // senha do usuario

      // Senha do Usuario - desemcryptada - moleza      secret
      rCampo := DECRYPT( ALLTRIM(( SER )->SENHACONTA ), "*+-." )
      cPass := ALLTRIM( rCampo ) // [kapiaba]

      // Configuracao do Servidor
      cServPOP3 :=  ALLTRIM( ( SER )->SEMAILPOP3 ) // Alfa
      cServSMTP :=  ALLTRIM( ( SER )->SEMAILSMTP ) // Alfa
      nServPORT :=         ( ( SER )->NPORTASERV ) // Numerico
      cServSEGU :=         ( ( SER )->CONEXAOSEG ) // Https/SSL? Servidor seguro? LOGICAL

      //aServs := { {"@pleno.com.br",      "smtp.pleno.com.br",        25, .F. } }
      aServs := { { cServPop3, cServSMTP, nServPORT, cServSEGU } }

      // Pega o servidor
      FOR i := 1 to LEN( aServs )
         AADD( aDomin, aServs[i][1] )
      NEXT

      IF nServ = 0 .OR. nServ > LEN(aServs)
         nServ := 1
      ENDIF

      cPOP3 := aServs[nServ][1]

      oSay[2]:SetText( cPOP3 )

      oGet[1]:VARPUT( LOWER( ccUser ) )
      oGet[1]:Refresh()

      oGet[3]:VARPUT( LOWER( ccUser ) )
      oGet[3]:Refresh()

   ELSE

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      DBGOTOP()

      IF EOF()

          MsgStop( OemToAnsi( "Ateno Usurio:                      " )+CRLF+;
                   OemToAnsi( "Banco de Dados Est Vazio, Cadastre   " )+CRLF+;
                   OemToAnsi( "os Elementos Para Esta Operao.      " )+CRLF+;
                   OemToAnsi( "Acesso No Permitido ao Banco de Dados" )+CRLF+;
                   OemToAnsi( "Entre em <Ferramentas> - <Provedores> " ),     ;
                   OemToAnsi( "Mensagem de Erro Para o Usurio.      " ) )

          GO TOP

          RETURN( .F. )

      ENDIF

      //-> Dialogo

      DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

      DEFINE FONT oFnt   NAME "Ms Sans Serif" SIZE 0, -12 BOLD //UnderLine
      DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

      DEFINE DIALOG oDlgSer  RESOURCE "BROWSE_SERVIDORES_EMAIL" ;
             BRUSH oBrush TRANSPARENT COLOR 0, 15790320

      oDlgSer:lHelpIcon := .F.

      oDlgSer:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                               + CRLF+ ;
                                                   "No Est Ativo" ), ;
                                      ( OemToAnsi( "Informao   " ) ) ) }

      For IDCor = 401 To 403 // Os ID's dos TEXTOS na DIALOG.
          REDEFINE           SAY ID IDCor OF oDlgSer        ;
          COLOR 0, 14671839  UPDATE FONT oFnt
      Next IDCor

      REDEFINE GROUP oGroup ID 501 OF oDlgSer                    ;
               COLOR CLR_BLACK                                   ;
               FONT oFnt TRANSPARENT

      // Listbox
      REDEFINE LISTBOX oLbxServ FIELDS                           ;
               ALLTRIM( ( cAlias )->NOMEDOUSUA ) +               ;
               ALLTRIM( ( cAlias )->SEMAILPOP3 )                 ;
               HEADERS ( OemToAnsi( "Usurio(s) " ) )            ;
               FIELDSIZES 445                                    ;
               COLOR CLR_BROWN, CLR_LGREEN                       ;
               FONT oFont                                        ;
               UPDATE                                            ;
               ID 101  OF oDlgSer                                ;
               ON DBLCLICK( lConfirma := .T., oDlgSer:End() )

      //-> Disparos Automaticos da ListBox
      oLbxServ:bKeyDown := { | nKey | IF ( nKey = VK_RETURN,     ;
                                         ( ( lConfirma := .T.,   ;
                                             oDlgSer:End() ) ),  ;
                                      IF ( nKey = VK_INSERT,     ;
                                         ( "" ),                 ;
                                      IF ( nKey = VK_DELETE,     ;
                                         ( "" ), ) ) ) }

      oLbxServ:cToolTip := OemToAnsi( "<Click-me> " )

      //-----------------------------------------------------------------------//
      oLbxServ:nClrBackHead  := CLR_LGREEN  // Cor do Fundo do Cabealho
      oLbxServ:nClrText      := {|| nRGB( 165,  42,  42 ) } // Cor do Fundo do Cabealho
      oLbxServ:nClrBackFocus := CLR_HRED    // Cor do Cursor Em Cima do tem
      oLbxServ:nClrForeFocus := CLR_AMARELO // Cor da letra da barra ativa
      oLbxServ:nClrForeHead  := CLR_HRED    // Cor nos Headers - Cabealhos
      // Cor no Pano de Fundo da Browse() Listbox-Legal - abaixo o comando
      oLbxServ:nClrPane      := { || IIF( ( oLbxServ:cAlias )->( OrdKeyNo() ) %2 == 0, ;
                                 CLR_LGREEN, CLR_LGRAY ) }
      oLbxServ:nColAct       := 1           // Onde o Cursor Vai Iniciar na coluna
      oLbxServ:nLineStyle    := 3           // Estilo das linhas nos dados da Browse
      oLbxServ:lCellStyle    := .T.         // Somente pinta a clula em que o cursor esta no momento
      // Justifica o Cabealho: .F. = Esquerda .T. = Centro
      oLbxServ:aJustify := { .F., .F., .F., .T., .T., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F. }
      oLbxServ:lMChange      := .F.         // Desabilita Mousemove - Movimentos do Mouse Congelam.
      oLbxServ:SetFocus()                   // Refocus on The Browse - Ativa o Foco na ListBox(Browse)
      oLbxServ:Refresh()                    // Estabiliza o Browse/Listbox - Refresca os Dados.
                                         // Pinta os Dados Novamente
      //-----------------------------------------------------------------------//

      // Botoes da ListBox

      REDEFINE BUTTON oConfirma ID 301 OF oDlgSer                   ;
               ACTION( lConfirma := .T., oDlgSer:End() )

      oConfirma:cToolTip := OemToAnsi( "Escolha Um dos Servidores " )

      REDEFINE BUTTON oSaida   ID 302 OF oDlgSer                    ;
               ACTION( lConfirma := .F., oDlgSer:End() ) CANCEL UPDATE

      oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

      SET FONT OF oConfirma TO oFont
      SET FONT OF oSaida    TO oFont

      ACTIVATE DIALOG oDlgSer CENTERED

      oBrush:End()
      oFnt:End()
      oFont:End()

      DO CASE
      CASE nKey == VK_ESCAPE .OR. GetKeyState( VK_ESCAPE ) .OR. .NOT. ;
                   lConfirma

         lConfirma := .F.

         lAchoUsuario := .F.

         RETURN( .F. )

      ENDCASE

      IF lConfirma // Botao 301, autorizou

         // Posiciona o Cursor no Registro
         nRecNo := ( cAlias )->( RecNo() )
         GoTo( nRecNo )

         TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

         cPass := SPACE(15)  // senha do usuario

         // Senha do Usuario - desemcryptada - moleza      secret
         rCampo := DECRYPT( ALLTRIM(( SER )->SENHACONTA ), "*+-." )
         cPass := ALLTRIM( rCampo ) // [kapiaba]

         // Configuracao do Servidor
         ccUser    :=  ALLTRIM( ( SER )->NOMEDOUSUA ) // Alfa
         cServPOP3 :=  ALLTRIM( ( SER )->SEMAILPOP3 ) // Alfa
         cServSMTP :=  ALLTRIM( ( SER )->SEMAILSMTP ) // Alfa
         nServPORT :=         ( ( SER )->NPORTASERV ) // Numerico
         cServSEGU :=         ( ( SER )->CONEXAOSEG ) // Https/SSL? Servidor seguro? LOGICAL

         //aServs := { {"@pleno.com.br",      "smtp.pleno.com.br",        25, .F. } }
         aServs := { { cServPop3, cServSMTP, nServPORT, cServSEGU } }

         // Pega o servidor
         FOR i := 1 to LEN( aServs )
            AADD( aDomin, aServs[i][1] )
         NEXT

         IF nServ = 0 .OR. nServ > LEN(aServs)
            nServ := 1
         ENDIF

         cPOP3 := aServs[nServ][1]

         oSay[2]:SetText( cPOP3 )

         oGet[1]:VARPUT( LOWER( ccUser ) )
         oGet[1]:Refresh()

         oGet[3]:VARPUT( LOWER( ccUser ) )
         oGet[3]:Refresh()

         lAchoUsuario := .T.

      ENDIF

      lConfirma := .F.

   ENDIF

RETURN( .T. )

// Email do destinatario, nao pode ir vazio

STATIC FUNCTION CHECA_GET_cDest( cDestino ) // Destinatario do Email(cDest)

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( cDestino ) .AND. GETASYNCKEY( VK_RETURN )

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgStop( OemToAnsi( "Ateno:                       " )+CRLF+ ;
               OemToAnsi( "Informe o Email de Destino.    " )+CRLF+ ;
                                                             +CRLF+ ;
               OemToAnsi( "Exemplo: contato@pleno.com.br  " )+CRLF+ ;
                                                             +CRLF+ ;
               OemToAnsi( "Ou Use a Tecla: <F7> Para Pegar" )+CRLF+ ;
               OemToAnsi( "o(s) Contato(s) Cadastrado(s). " ),      ;
               OemToAnsi( "Informe Email(s) de Destino.   " ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

STATIC FUNCTION CHECA_GET_cAssunto( ccAssunto ) // asunto do email(cAssunto)

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( ccAssunto )

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgStop( OemToAnsi( "Ateno:                    " )+CRLF+ ;
               OemToAnsi( "Informe o Assunto do Email. " )+CRLF+ ;
               OemToAnsi( "Campo Obrigatrio.          " ),      ;
               OemToAnsi( "Informe o Assunto do Email. " ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

//-> ACIONA O TIMER DO RELOGIO NO DIALOGO

STATIC FUNCTION ACIONA_TIMER( oWnd )

   DEFINE TIMER oTimerRelog INTERVAL 50  OF oDlgIni                         ;
          ACTION MUDATITULO( oWnd )

   ACTIVATE TIMER oTimerRelog

RETURN NIL

//-> Muda o Titulo do Dialogo

STATIC FUNCTION MUDATITULO( oWnd )

    LOCAL TITULO

    IF ISWINDOWVISIBLE( oDlgIni:hWnd )

       TITULO := cTitleDial + " :: Hoje: " + DTOC( Date() ) + ;
                              " :: Hora: " + TIME()

       oDlgIni:SETTEXT( TITULO )

    ENDIF

RETURN NIL

//------------------------------------------------------------------------------
FUNCTION INICIO( oDlgIni )

   MENU oMenu

      MENUITEM "&Configurar "

      MENU
         MENUITEM oM2 PROMPT "&Salvar Contatos Automaticamente" CHECK;
             ACTION IF( oM2:lChecked, oM2:SetCheck(.F.), oM2:SetCheck(.T.) )

         SEPARATOR
         MENUITEM "&Sair "         ;
             RESOURCE "SAIDA16X16" ;
             ACTION( oDlgIni:End() )

      ENDMENU

      MENUITEM "&Ferramentas"

      MENU

         MENUITEM "&Gerenciar Contatos" ;
             RESOURCE "ESTOQUE19"       ;
             ACTION( CONTATOS() ) // Cadastro de Emails

         SEPARATOR
         MENUITEM "&Provedores "   ;
             RESOURCE "ESTOQUE06"  ;
             ACTION( BROWSE_BOTOES_SERVIDORES() ) // Cadastro de Servidores

         SEPARATOR
         MENUITEM "&Manuteno "   ;
             RESOURCE "ESTOQUE07"  ;
             ACTION( MANUTENCAO() ) // Manutencao dos Bancos de dados

      ENDMENU

   ENDMENU

   oM2:SetCheck( lCheck )

   oDlgIni:SetMenu(oMenu)

RETURN( oMenu ) // NIL

// -> Browse que mostra os servidores cadastrados

FUNCTION BROWSE_BOTOES_SERVIDORES( lAppend )

   LOCAL oFont, oFnt, iDcor, oBrush, oIco, oDlgBtn, oLbxServ, cAlias
   LOCAL oHand, oIncluir, oExcluir, oAlterar, oImprimir, oSaida

   // Banco de dados dos Servidores de Email
   SELECT( DbServidor:cAlias )
   // SET INDEX TO SERVPOP3, SERVSMTP, NOMEUSUA
   SET INDEX TO SERVPOP3

   cAlias := ALIAS()
   // Para a Impressao ja peguei pronto de GASFW.EXE em C:\GASFW mantive
   SER    := ALIAS() //-> ALIAS de: SERVIDOR.DBF
   SELECT( SER )
   DBGOTOP()

   //-> Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFnt   NAME "Ms Sans Serif" SIZE 0, -12 BOLD //UnderLine
   DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgBtn  RESOURCE "BROWSE_PROVEDORES_EMAIL" ;
          BRUSH oBrush TRANSPARENT COLOR 0, 15790320

   oDlgBtn:lHelpIcon := .F.

   oDlgBtn:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                            + CRLF+ ;
                                                "No Est Ativo" ), ;
                                   ( OemToAnsi( "Informao   " ) ) ) }

   REDEFINE GROUP oGroup ID 501 OF oDlgBtn                    ;
            COLOR CLR_BLACK                                   ;
            FONT oFnt TRANSPARENT

   // Listbox
   REDEFINE LISTBOX oLbxServ FIELDS                                         ;
            ( cAlias )->SEMAILPOP3                                        , ;
            ( cAlias )->SEMAILSMTP                                        , ;
            ( cAlias )->SEMAILCONT                                        , ;
            TRANSF( ( cAlias )->NPORTASERV, "999" )                       , ;
            IIF( ( cAlias )->CONEXAOSEG= .T., "Sim", "No" )              , ;
            ( cAlias )->NOMEDOUSUA                                        , ;
            SPACE(01)                                                       ;
            HEADERS ( OemToAnsi( "Servidor de Entrada (POP3) " ) )        , ;
                    ( OemToAnsi( "Servidor de Saida (SMTP) "   ) )        , ;
                    ( OemToAnsi( "Nome da Conta de Email "     ) )        , ;
                    ( OemToAnsi( "Porta N "                   ) )        , ;
                    ( OemToAnsi( "Https? "                     ) )        , ;
                    ( OemToAnsi( "Usurio do Email(Somente Nome) " ) )    , ;
                    ( OemToAnsi( " - "                         ) )          ;
            FIELDSIZES 320, 320, 320, 080, 060, 320, 010                    ;
            COLOR CLR_BROWN, CLR_LGREEN                                     ;
            FONT oFont                                                      ;
            UPDATE                                                          ;
            ID 101  OF oDlgBtn                                              ;
            ON DBLCLICK( SERVIDORES( lAppend := .F. ), oLbxServ:SetFocus(), ;
                                                       oLbxServ:Refresh(),  ;
                                                       oLbxServ:DrawSelect() )

   // Nas Novas Versoes, pode-se fazer assim.. eu acho... se entendi...
   //  oLbx:cTooltip :={ "POLIZAS DE AUTOS (C)Copyright 2010 - Por Aida Sistemas S.A.", "POLIZARIUM",1,CLR_WHITE,CLR_HBLUE }
   oLbxServ:cToolTip := OemToAnsi( "<Click-me> " )

   //-> Disparos Automaticos da ListBox
   oLbxServ:bKeyDown := { | nKey | IF ( nKey = VK_RETURN,                   ;
                                      ( ( SERVIDORES( lAppend := .F. ) ),   ;
                                          oLbxServ:Refresh(),               ;
                                          oLbxServ:SetFocus(),              ;
                                          oLbxServ:DrawSelect() ),          ;
                                   IF ( nKey = VK_INSERT,                   ;
                                      ( "" ),                               ;
                                   IF ( nKey = VK_DELETE,                   ;
                                      ( "" ), ) ) ) }

   //-----------------------------------------------------------------------//
   oLbxServ:nClrBackHead  := CLR_LGREEN  // Cor do Fundo do Cabealho
   oLbxServ:nClrText      := {|| nRGB( 165,  42,  42 ) } // Cor do Fundo do Cabealho
   oLbxServ:nClrBackFocus := CLR_HRED    // Cor do Cursor Em Cima do tem
   oLbxServ:nClrForeFocus := CLR_AMARELO // Cor da letra da barra ativa
   oLbxServ:nClrForeHead  := CLR_HRED    // Cor nos Headers - Cabealhos
   // Cor no Pano de Fundo da Browse() Listbox-Legal - abaixo o comando
   oLbxServ:nClrPane      := { || IIF( ( oLbxServ:cAlias )->( OrdKeyNo() ) %2 == 0, ;
                              CLR_LGREEN, CLR_LGRAY ) }
   oLbxServ:nColAct       := 1           // Onde o Cursor Vai Iniciar na coluna
   oLbxServ:nLineStyle    := 3           // Estilo das linhas nos dados da Browse
   oLbxServ:lCellStyle    := .T.         // Somente pinta a clula em que o cursor esta no momento
   // Justifica o Cabealho: .F. = Esquerda .T. = Centro
   oLbxServ:aJustify := { .F., .F., .F., .T., .T., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F., .F. }
   oLbxServ:lMChange      := .F.         // Desabilita Mousemove - Movimentos do Mouse Congelam.
   oLbxServ:SetFocus()                   // Refocus on The Browse - Ativa o Foco na ListBox(Browse)
   oLbxServ:Refresh()                    // Estabiliza o Browse/Listbox - Refresca os Dados.
                                         // Pinta os Dados Novamente
   //-----------------------------------------------------------------------//

   // Botoes da ListBox

   REDEFINE BUTTON oIncluir  ID 301 OF oDlgBtn                         ;
            ACTION( SERVIDORES( lAppend := .T. ), oLbxServ:SetFocus(), ;
                                                  oLbxServ:Refresh(),  ;
                                                  oLbxServ:DrawSelect() )

   oIncluir:cToolTip := OemToAnsi( "Incluir Novo Provedor de Email " )

   REDEFINE BUTTON oExcluir  ID 302 OF oDlgBtn                         ;
            ACTION( SERVIDORES( lAppend := .F., lExcluiServ := .T. ),  ;
                                                oLbxServ:SetFocus(),   ;
                                                oLbxServ:Refresh(),    ;
                                                oLbxServ:DrawSelect() )

   oExcluir:cToolTip := OemToAnsi( "Excluir o Provedor de Email " )

   REDEFINE BUTTON oAlterar  ID 303 OF oDlgBtn                         ;
            ACTION( SERVIDORES( lAppend := .F. ), oLbxServ:SetFocus(), ;
                                                  oLbxServ:Refresh(),  ;
                                                  oLbxServ:DrawSelect() )

   oAlterar:cToolTip := OemToAnsi( "Alterar o Provedor de Email " )

   REDEFINE BUTTON oImprimir ID 304 OF oDlgBtn                   ;
            ACTION( IMPRIMESER( oLbxServ ) )

   oImprimir:cToolTip := OemToAnsi( "Imprimir Relao de Servidores " )

   REDEFINE BUTTON oSaida   ID 305 OF oDlgBtn                       ;
            ACTION( oDlgBtn:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oIncluir  TO oFont
   SET FONT OF oExcluir  TO oFont
   SET FONT OF oAlterar  TO oFont
   SET FONT OF oImprimir TO oFont
   SET FONT OF oSaida    TO oFont

   ACTIVATE DIALOG oDlgBtn CENTERED

   oBrush:End()
   oFnt:End()
   oFont:End()

RETURN NIL

// Cadastrar / alterar / excluir um servidor

FUNCTION SERVIDORES( lAppend )

   //-> Campos(Fields) do Banco de Dados - SERVIDOR.DBF
   FIELD SEMAILPOP3, SEMAILSMTP, SEMAILCONT, NPORTASERV, CONEXAOSEG,  ;
         NOMEDOUSUA, SENHACONTA

   LOCAL oFont, oFnt, iDcor, oBrush, oIco, cCampo, rCampo, oTahoma
   LOCAL oHand, oGravar, oExcluir, oSaida
   LOCAL aGet := ARRAY(10)
   LOCAL lLembraSenha := .F.
   LOCAL nRecNo, cAlias

   // Variaveis dos Gets
   MEMVAR XEMAILENTPOP3, XEMAILSAISMTP, XEMAILNOCONTA, XSENHADACONTA, ;
          XNUMEROPORTA,  XCONEXAOSEGUR, XNOMEUSUARIO

   PRIVATE oDlgServ

   TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

   // area da inclusao/exclusao/alteracao
   IF lAppend  // Inclusao de um novo provedor de email

      // POP3
      XEMAILENTPOP3 := SPACE(40)

      // SMTP
      XEMAILSAISMTP := SPACE(40)

      // NOME DA CONTA DE EMAIL - Ex: contato@pleno.com.br
      XEMAILNOCONTA := SPACE(40)

      // SENHA DA CONTA DO USUARIO - Ex.: senha do provedor de email
      XSENHADACONTA := SPACE(40)  // acho que exagerei na senha + vai q...

      // NUMERO DA PORTA DO SERVIDOR - 587 e segura, sem spam. eu acho...
      XNUMEROPORTA  := 587  // EX.: 25-110-465-587-995

      // TLS/SSL Necessrio? sim (.t.) ou no(.f.) - Conexao segura? .T. .F.
      XCONEXAOSEGUR := [N]  // Campo LOGICAL do Banco de Dados

      // MOME DO USUARIO DO EMAIL - Ex.: Joao sem o @pleno.com.br
      XNOMEUSUARIO := SPACE(40)

   ELSE // Alteracao de um provedor de email

      IF EOF()

          MsgStop( OemToAnsi( "Ateno Usurio:                      " )+CRLF+;
                   OemToAnsi( "Banco de Dados Est Vazio, Cadastre   " )+CRLF+;
                   OemToAnsi( "os Elementos Para Esta Operao.      " )+CRLF+;
                   OemToAnsi( "Acesso No Permitido ao Banco de Dados" ),     ;
                   OemToAnsi( "Mensagem de Erro Para o Usurio.      " ) )

          GO TOP

          RETURN( .F. )

      ENDIF

      cAlias := ALIAS()

      // Posiciona o Cursor no Registro
      nRecNo := ( cAlias )->( RecNo() )
      GoTo( nRecNo )

      // Variaveis do programa
      //XEMAILENTPOP3 := SPACE(40)
      // POP3 - Ex.: // [@parthenonassessoria.com.br             ]
      XEMAILENTPOP3 := ( cAlias )->SEMAILPOP3

      // SMTP - Ex.: // [smtp.parthenonassessoria.com.br         ]
      XEMAILSAISMTP := ( cAlias )->SEMAILSMTP

      // NOME DA CONTA DE EMAIL - Ex: contato@pleno.com.br
      // CONTA - Ex.: [marcos@parthenonassessoria.com.br       ]
      XEMAILNOCONTA := ( cAlias )->SEMAILCONT

      // SENHA DA CONTA DO USUARIO - Ex.: [cardim123   ]  // 12 DIGITOS
      //-> Retorno da Senha do Banco de Dados Desemcrypitada
      //-> Para Igual-la a cChave -> Para Alterao.  // Secreto
      rCampo := DECRYPT( ALLTRIM(( cAlias )->SENHACONTA ), "*+-." )

      XSENHADACONTA := ALLTRIM( rCampo )+SPACE(30)

      IF EMPTY( XSENHADACONTA )

         XSENHADACONTA := SPACE(40)  // acho que exagerei na senha + vai q...

      ENDIF

      //? rCampo, XSENHADACONTA

      // NUMERO DA PORTA DO SERVIDOR // EX.: 25-110-465-587-995
      XNUMEROPORTA  := ( cAlias )->NPORTASERV

      // TLS/SSL Necessrio? sim (.t.) ou no(.f.) - Conexao segura? .T. .F.
      IF ( cAlias )->CONEXAOSEG = .T.  // Campo LOGICAL no Banco de Dados
         XCONEXAOSEGUR := [S]
      ELSE
         XCONEXAOSEGUR := [N]
      ENDIF

      // NOME DO USUARIO SEM O @pleno.com.br por exemplo
      XNOMEUSUARIO := ( cAlias )->NOMEDOUSUA

      //-> Desliga os Gets
      IF lExcluiServ .AND. .NOT. lAppend // Exclusao/Consultas
         lConsulta := .F.
      ENDIF

   ENDIF

   //-> Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFnt   NAME "Ms Sans Serif" SIZE 0, -12 BOLD //UnderLine
   DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine
   DEFINE FONT oTahoma NAME "Tahoma"       SIZE 0, -12 BOLD // Para a senha

   DEFINE DIALOG oDlgServ  RESOURCE "DLG_PROVEDORES" ;
          BRUSH oBrush TRANSPARENT

   oDlgServ:lHelpIcon := .F.

   oDlgServ:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                             + CRLF+ ;
                                                 "No Est Ativo" ), ;
                                    ( OemToAnsi( "Informao   " ) ) ) }

   For IDCor = 401 To 415 // Os ID's dos TEXTOS na DIALOG.
       REDEFINE           SAY ID IDCor OF oDlgServ        ;
       COLOR CLR_BLACK    UPDATE FONT oFnt
   Next IDCor

   REDEFINE GROUP oGroup ID 501 OF oDlgServ                    ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 135, 206, 235 ) ;
            FONT oFnt TRANSPARENT

   REDEFINE GROUP oGroup ID 502 OF oDlgServ                    ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 135, 206, 235 ) ;
            FONT oFnt TRANSPARENT

   REDEFINE GROUP oGroup ID 503 OF oDlgServ                    ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 135, 206, 235 ) ;
            FONT oFnt TRANSPARENT

   //-> Get's

   //-> Emai de Entrada: Ex: @parthenonassessoria.com.br
   //-> Mesma coisa que: Ex: pop3.parthenonassessoria.com.br   40 c eu acho
   //-> XEMAILENTPOP3 - ENTRADA DO POP3
   REDEFINE GET aGet[1]   VAR  XEMAILENTPOP3 PICTURE "@K"      ;
            ID 20 OF oDlgServ                                  ;
            FONT oFnt UPDATE                                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID( CHECA_GET_POP3( XEMAILENTPOP3 ) )           ;
            WHEN( lConsulta )

   aGet[1]:cToolTip := ( "Email de Entrada(POP3) - Ex.: @pleno.com.br " )

   //-> SMTP ex: smtp.parthenonassessoria.com.br
   //-> XEMAILSAISMTP - SAIDA DO SMTP
   REDEFINE GET aGet[2]   VAR  XEMAILSAISMTP PICTURE "@K"      ;
            ID 21 OF oDlgServ                                  ;
            FONT oFnt UPDATE                                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID( CHECA_GET_SMTP( XEMAILSAISMTP ) )           ;
            WHEN( lConsulta )

   aGet[2]:cToolTip := ( "Email de Saida(SMTP) - Ex.: smtp.pleno.com.br " )

   // NOME DA CONTA DE EMAIL - Ex: contato@pleno.com.br
   // XEMAILNOCONTA  := [marcos@parthenonassessoria.com.br      ]
   REDEFINE GET aGet[3]   VAR  XEMAILNOCONTA PICTURE "@K"      ;
            ID 22 OF oDlgServ                                  ;
            FONT oFnt UPDATE                                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID( CHECA_GET_CONTA( XEMAILNOCONTA ) )          ;
            WHEN( lConsulta )

   aGet[3]:cToolTip := ( "Nome da Conta de Email - Ex.: contato@pleno.com.br " )

   // SENHA DA CONTA DO USUARIO - Ex.:
   // XSENHADACONTA := [cardim123                               ]
   REDEFINE GET aGet[4]   VAR  XSENHADACONTA PICTURE "@K"      ;
            ID 23 OF oDlgServ                                  ;
            FONT oTahoma UPDATE                                ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID( CHECA_GET_SENHA( XSENHADACONTA ) )          ;
            WHEN( lConsulta )

   aGet[4]:cToolTip := ( "Sua Senha no Provedor de Email " )

   // NUMERO DA PORTA DO SERVIDOR
   // XNUMEROPORTA := 25 // EX.: 25-110-465-587-995
   REDEFINE GET aGet[5]   VAR  XNUMEROPORTA PICTURE "@K 9999"  ;
            ID 24 OF oDlgServ                                  ;
            FONT oFnt UPDATE                                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID( CHECA_GET_PORTA( XNUMEROPORTA ) )           ;
            WHEN( lConsulta )

   aGet[5]:cToolTip := ( "Nmero da Porta do Servidor de Email " + ;
                         "EX.: 25-110-465-587-995 " )

   // TLS/SSL Necessrio? sim (.t.) ou no(.f.) - Conexao segura? .T. .F.
   //XCONEXAOSEGUR
   REDEFINE GET aGet[6]   VAR  XCONEXAOSEGUR PICTURE "@K!"     ;
            ID 25 OF oDlgServ                                  ;
            FONT oFnt UPDATE                                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 ) ;
            VALID AT( XCONEXAOSEGUR, "SN" ) # 0                ;
            WHEN( lConsulta )

   aGet[6]:cToolTip := ( "Conexo Segura? " +                  ;
                         "TLS/SSL ( Transport Layer Security ) " )

   // NOME DO USUARIO SEM O @pleno.com.br por exemplo - Minusculo
   // XNOMEUSUARIO := ( cAlias )->NOMEDOUSUA
   REDEFINE GET aGet[7]   VAR  XNOMEUSUARIO PICTURE "@K"        ;
            ID 26 OF oDlgServ                                   ;
            FONT oFnt UPDATE                                    ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 243, 250, 200 )  ;
            VALID( CHECA_GET_USUARIO( XNOMEUSUARIO, oGravar ) ) ;
            WHEN( lConsulta )

   aGet[7]:cToolTip := ( "Nome do Usurio SEM o @dominio.com.br, Somente o Nome. " )

   //----------------------------------------------------------------------//

   // Botoes

   IF lExcluiServ .AND. .NOT. lAppend // :=  .T. e .F. //Exclusao

      REDEFINE BUTTON oExcluir ID 301 OF oDlgServ                       ;
               PROMPT( "&Excluir " )                                    ;
               ACTION( ( EXCLUIR_SERVIDOR() ), oDlgServ:End() )

      oExcluir:cToolTip := OemToAnsi( "Excluir Informaes do Servidor " + ;
                                      "de Emails " )

      SET FONT OF oExcluir  TO oFont

   ELSE // Gravacao das Informacoes

      REDEFINE BUTTON oGravar  ID 301 OF oDlgServ                       ;
               WHEN( lLigaBotao )                                       ;
               ACTION( GRAVAR_SERVIDOR( lAppend, oDlgServ ) )

      oGravar:cToolTip := OemToAnsi( "Gravar Informaes do Servidor " + ;
                                     "de Emails " )

      SET FONT OF oGravar   TO oFont

   ENDIF

   REDEFINE BUTTON oSaida   ID 302 OF oDlgServ                       ;
            ACTION( oDlgServ:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oSaida    TO oFont

   // =  .T. e .F. // Exclusao - Entra aqui
   IF lExcluiServ .AND. .NOT. lAppend

      ACTIVATE DIALOG oDlgServ CENTERED ;
               ON INIT( XFOCUS( oSaida ) )

   ELSE // Normal: inclusao/alteracao/impressao

      ACTIVATE DIALOG oDlgServ CENTERED

   ENDIF

   oBrush:End()
   oFnt:End()
   oFont:End()
   oTahoma:End()

   lExcluiServ := .F.
   lConsulta   := .T.
   lLigaBotao := .F.

RETURN NIL

// Servidor POP3  - Servidor de Entrada

STATIC FUNCTION CHECA_GET_POP3( cEMAILENTPOP3 )

   IF GETASYNCKEY( VK_UP )
      RETURN( .F. )
   ENDIF

   IF EMPTY( cEMAILENTPOP3 )  // = a XEMAILENTPOP3

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                            " )+CRLF+ ;
               OemToAnsi( "Digite o Servidor de Entrada(POP3). " )+CRLF+ ;
               OemToAnsi( "Informe-se Com o Seu Provedor de    " )+CRLF+ ;
               OemToAnsi( "Internet(Email). Campo Obrigatrio. " )+CRLF+ ;
               OemToAnsi( "Ex.: @pleno.com.br / @hotmail.com   " ),      ;
               OemToAnsi( "Servidor No Informado.   Cuidado!!!" ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

// Servidor de SMTP - Servidor de Saida

STATIC FUNCTION CHECA_GET_SMTP( cEMAILSAISMTP )

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( cEMAILSAISMTP )  // = a XEMAILSAISMTP

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                            " )+CRLF+ ;
               OemToAnsi( "Digite o Servidor de Saida(SMTP).   " )+CRLF+ ;
               OemToAnsi( "Informe-se Com o Seu Provedor de    " )+CRLF+ ;
               OemToAnsi( "Internet(Email). Campo Obrigatrio. " )+CRLF+ ;
               OemToAnsi( "Exemplo: smtp.pleno.com.br          " ),      ;
               OemToAnsi( "Servidor No Informado.   Cuidado!!!" ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

// Conta do Email

STATIC FUNCTION CHECA_GET_CONTA( cEMAILNOCONTA )

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( cEMAILNOCONTA )  // = a XEMAILNOCONTA

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                            " )+CRLF+ ;
               OemToAnsi( "Digite o Nome da Conta de Email.    " )+CRLF+ ;
               OemToAnsi( "Exemplo: contato@pleno.com.br       " ),      ;
               OemToAnsi( "Email(Conta) No Informado. Cuidado!" ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

// Senha do usuario - sem ela nao funcionara corretamente.

STATIC FUNCTION CHECA_GET_SENHA( cSENHADACONTA )

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( cSENHADACONTA )  // = a XSENHADACONTA

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                            " )+CRLF+ ;
               OemToAnsi( "Digite a Sua Senha do Provedor.     " )+CRLF+ ;
               OemToAnsi( "A Mesma Que Voc Entra no Seu Email " )+CRLF+ ;
               OemToAnsi( "Ou Pea ao Administrador da Rede,   " )+CRLF+ ;
               OemToAnsi( "Para Cadastrar a Senha Correta.     " )+CRLF+ ;
               OemToAnsi( "Se a Senha No For a Mesma, Voc    " )+CRLF+ ;
               OemToAnsi( "No Conseguir Enviar o Email.      " ),      ;
               OemToAnsi( "Aviso: Senha Correta No Informada. " ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

// Porta do Servidor

STATIC FUNCTION CHECA_GET_PORTA( nNUMEROPORTA )

   IF GETASYNCKEY( VK_UP )
      RETURN( .T. )
   ENDIF

   IF EMPTY( nNUMEROPORTA )  // = a XNUMEROPORTA

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                           " )+CRLF+ ;
               OemToAnsi( "Digite o N. da Porta do Servidor. " )+CRLF+ ;
               OemToAnsi( "Informe-se Com o Seu Provedor de   " )+CRLF+ ;
               OemToAnsi( "Internet(Email). Campo Obrigatrio." )+CRLF+ ;
               OemToAnsi( "Exemplo: 25-110-465-587-995        " ),      ;
               OemToAnsi( "Porta do Servidor No Informada.   " ) )

      RETURN( .F. )

   ENDIF

RETURN( .T. )

//-> Nome do usuario do Email sem o @dominio.com.br

STATIC FUNCTION CHECA_GET_USUARIO( cNOMEUSUARIO, oGravar )

   IF GETASYNCKEY( VK_UP )

      lLigaBotao := .F.

      oGravar:Disable()
      oGravar:Refresh()

      RETURN( .T. )

   ENDIF

   IF EMPTY( cNOMEUSUARIO )  // = a XNOMEUSUARIO

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Ateno:                              " )+CRLF+ ;
               OemToAnsi( "Digite o Nome do Usurio do Email.    " )+CRLF+ ;
               OemToAnsi( "Exemplo: contato@pleno.com.br         " )+CRLF+ ;
               OemToAnsi( "Digite: contato SEM o @pleno.com.br   " )+CRLF+ ;
               OemToAnsi( "Digite Somente o Nome do Usurio.     " )+CRLF+ ;
               OemToAnsi( "Sem o Dominio do Provedor de Internet." )+CRLF+ ;
               OemToAnsi( "NO Digite o Email Completo.  Ateno!" ),      ;
               OemToAnsi( "Nome do Usurio do Email No Informado" ) )

      lLigaBotao := .F.

      oGravar:Disable()
      oGravar:Refresh()

      RETURN( .F. )

   ENDIF

   lLigaBotao := .T.

   oGravar:Enable()
   oGravar:Refresh()

RETURN( .T. )

//-> Gravacao das Informacoes dos Servidores // Inclusao/Alteracao

STATIC FUNCTION GRAVAR_SERVIDOR( lAppend, oDlgServ )

   LOCAL oDlgGrava, oFnt, oFont, oGroup, oGravar, oSaida, IDCor, oBrush
   LOCAL nRegistro := Recno(), nKey := VK_RETURN
   LOCAL lSalvar := .F., cCampo, rCampo, cChave

   // Variaveis dos Gets
   MEMVAR XEMAILENTPOP3, XEMAILSAISMTP, XEMAILNOCONTA, XSENHADACONTA, ;
          XNUMEROPORTA,  XCONEXAOSEGUR, XNOMEUSUARIO

   //-> Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFnt   NAME "Ms Sans Serif" SIZE 0, -12 BOLD //UnderLine
   DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgGrava  RESOURCE "DLG_GRAVAR_PROVEDOR"     ;
          BRUSH oBrush TRANSPARENT

   oDlgGrava:lHelpIcon := .F.

   oDlgGrava:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                              + CRLF+ ;
                                                  "No Est Ativo" ), ;
                                     ( OemToAnsi( "Informao   " ) ) ) }

   For IDCor = 401 To 402 // Os ID's dos TEXTOS na DIALOG.
       REDEFINE           SAY ID IDCor OF oDlgGrava       ;
       COLOR CLR_BLACK    UPDATE FONT oFnt
   Next IDCor

   REDEFINE GROUP oGroup ID 501 OF oDlgGrava                   ;
            COLOR nRGB( 000, 000, 000 ), nRGB( 135, 206, 235 ) ;
            FONT oFnt TRANSPARENT

   // Botoes

   REDEFINE BUTTON oGravar   ID 301 OF oDlgGrava                         ;
            ACTION( lSalvar := .T., oDlgGrava:End() )

   oGravar:cToolTip := OemToAnsi( "Gravar Informaes do Servidor " )

   REDEFINE BUTTON oSaida   ID 302 OF oDlgGrava                       ;
            ACTION( lSalvar := .F., oDlgGrava:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oGravar   TO oFont
   SET FONT OF oSaida    TO oFont

   ACTIVATE DIALOG oDlgGrava CENTERED

   oBrush:End()
   oFnt:End()
   oFont:End()

   //-> Se for teclado ESCAPE na Browse do ESTOQUE.PRG
   DO CASE
   CASE nKey == VK_ESCAPE .OR. GetKeyState( VK_ESCAPE )

       lSalvar := .F.

       oDlgServ:End()

       RETURN( .F. )

   ENDCASE

   // Botao da Gravacao autorizou - Gravara
   IF lSalvar

      IF lAppend //-> Novo Registro
         NewRecord()
      ENDIF      

      IF .NOT. RecordLock() //-> Trava o registro

         REPLACE SEMAILPOP3 WITH LOWER( XEMAILENTPOP3 )
         REPLACE SEMAILSMTP WITH LOWER( XEMAILSAISMTP )
         REPLACE SEMAILCONT WITH LOWER( XEMAILNOCONTA )
         REPLACE NPORTASERV WITH XNUMEROPORTA

         IF XCONEXAOSEGUR = [S]
            REPLACE CONEXAOSEG WITH .T.
         ELSE
            REPLACE CONEXAOSEG WITH .F.
         ENDIF

         REPLACE NOMEDOUSUA WITH LOWER( XNOMEUSUARIO )

         //-> Colocar Encrypt na senha conforme abaixo
         cChave := LOWER( XSENHADACONTA )
         cCampo := ENCRYPT( ALLTRIM( cChave ),"*+-.")

         // Para nao gravar senha em branco - apenas seguranca
         IF .NOT. EMPTY( cChave )

             REPLACE SENHACONTA WITH cCampo  //-> Grava a senha final

         ENDIF

      ENDIF      

      COMMIT
      UNLOCK

      DbGoto( nRegistro )

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      MsgInfo( OemToAnsi( "Gravao Efetuada Com Sucesso! " ), ;
               OemToAnsi( "Aviso da Gravao              " ) )

   ENDIF

   oDlgServ:End()  // Derruba o dialogo

RETURN NIL

//-> NewRecord - Cria Novo Registro                   

STATIC FUNCTION NEWRECORD()

   DBAPPEND() 

   IF NETERR() 

      MsgInfo( "Erro: No posso criar um novo registro ", "Aviso " )

      RETURN( .F. ) 

   ENDIF 

RETURN( .T. ) 

//--------------------------------------------------------------------------//

//-> RecordLock - Trava o Registro                    

STATIC FUNCTION RECORDLOCK()

   LOCAL ABORTED := .F. 
   LOCAL TRY := 1

   DO WHILE .NOT. RLOCK()

      SYSREFRESH()

      INKEY(0.5) 

      IF ++TRY > 10 

         ABORTED := .T. 
         EXIT 

      ENDIF 

   ENDDO 

   IF ABORTED 

      MsgInfo( "Registro bloqueado por outro usurio", "Aviso " )

   ENDIF 

RETURN( ABORTED )

//-> Exclusao do Servidor

STATIC FUNCTION EXCLUIR_SERVIDOR()

   //-> Erro
   TONE(3000,1)
   TONE(2000,1)
   TONE(1000,1)

   //-> Alerta
   TONE(2500,9)
   TONE(2500,9)

   IF MsgNoYes( OemToAnsi( "ATENO:                         " )+CRLF+ ;
                                                                +CRLF+ ;
                OemToAnsi( "APS CONFIRMAR A EXCLUSO DO     " )+CRLF+ ;
                OemToAnsi( "SERVIDOR NO BANCO DE DADOS:      " )+CRLF+ ;
                                                                +CRLF+ ;
                OemToAnsi( "A EXCLUSO, NO PODER SER       " )+CRLF+ ;
                OemToAnsi( "REVERTIDA, EM HIPTESE NENHUMA.  " )+CRLF+ ;
                                                                +CRLF+ ;
                OemToAnsi( "<S>im Para Excluir o Servidor.   " )+CRLF+ ;
                OemToAnsi( "<N>o Para No Excluir o Servidor" ),      ;
                OemToAnsi( "Perda Irrecupervel!! Cuidado!!! " ) ) = .F.

      TONE(2500,9)

      MsgInfo( OemToAnsi( "Servidor No Excluido!       " ) +CRLF+ ;
               OemToAnsi( "Tecle <ENTER> Para Continuar " ),       ;
               OemToAnsi( "Servidor No Foi Excluido!   " ) )

      RETURN( .F. )

   ENDIF

   TONE(2500,9)

   IF MsgNoYes( OemToAnsi( "MOTIVO DE SEGURANA:             " ) +CRLF+ ;
                                                               +CRLF+ ;
                OemToAnsi( "CONFIRMA EXCLUSO DO SERVIDOR?   " ) +CRLF+ ;
                                                                  +CRLF+ ;
                OemToAnsi( "<S>im Para Excluir o Servidor    " ) +CRLF+ ;
                OemToAnsi( "<N>o Para No Excluir o Servidor" ),       ;
                OemToAnsi( "ltima Chance Para Desistir!!!   " ) ) = .F.

      RETURN( .F. )

   ENDIF

   IF .NOT. RecordLock() //-> Trava o registro

      DELETE

   ENDIF

   COMMIT
   UNLOCK

RETURN NIL

STATIC FUNCTION MANUTENCAO()

  MsgInfo( OemToAnsi( "Aguarde Dessenvolvimento... " ), ;
           OemToAnsi( "Em Desenvolvimento...       " ) )

RETURN NIL

//-----------------------------------------------------------------------------
FUNCTION Fim( cUser, cRemt, nServ )

   IF .NOT. EMPTY( cUser )  // Pode Gravar
      MemoWrit("dadosmail.dat", cUSER+CRLF+cREMT+CRLF+Str(nServ)+CRLF+if(oM2:lChecked, "1", "0") )
   ENDIF
 
RETURN( .T. )

****************************************************************************

FUNCTION Config_Mail(_cUser,cPass,_cRemt,cDest, cCC, cCCO, cTxt, cSubject)

   LOCAL lRet := .F.
   LOCAL oCfg, oError
   LOCAL cServPOP3 := aServs[nServ][1] //--> SERVIDOR POP3 - "@servidor.com.br"
   LOCAL cServSMTP := aServs[nServ][2] //--> SERVIDOR SMTP - "smtp.servidor.com.br"
   LOCAL nPort     := aServs[nServ][3]
   LOCAL lAut      := .T.
   LOCAL lSSL      := aServs[nServ][4]

   // Envia o email

   IF Empty( cPass )    .OR.  ;
      Empty( _cRemt )   .OR.  ;
      ( Empty( cDest )  .AND. ;
        Empty( cCC )    .AND. ;
        Empty( cCCO ) )

      MsgStop( OemToAnsi( "Preencha Todos os Campos " )+CRLF+ ;
               OemToAnsi( "Verifique o Remetente.   " )+CRLF+ ;
               OemToAnsi( "Verifique o Destinrio.  " ), ;
               OemToAnsi( "Ateno, Falha no Envio. " ) )

      RETURN( .F. )

   ELSE

      /* // era assim
      cUser := ALLTRIM( _cUser ) + aDomin[nServ]
      cRemt := ALLTRIM( _cRemt ) + aDomin[nServ]
      */

      cUser := ALLTRIM( _cUser ) + ALLTRIM( cServPOP3 )
      cRemt := ALLTRIM( _cRemt ) + ALLTRIM( cServPOP3 )

   ENDIF

   TRY

      oCfg := CREATEOBJECT( "CDO.Configuration" )

      WITH OBJECT oCfg:Fields

         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserver"       ):Value := cServSMTP // Servidor SMTP
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserverport"   ):Value := nPort
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusing"        ):Value := 2
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate" ):Value := lAut
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpusessl"       ):Value := lSSL
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusername"     ):Value := cUser
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendpassword"     ):Value := cPass
         :UPDATE()

      END WITH

      lRet := .T.

   CATCH oError

      MsgInfo( "No Foi Possvel Enviar o E-Mail!"  +CRLF+ ;
               "Verifique o Remetente            "  +CRLF+ ;
               "Verifique o Destinatrio         "  +CRLF+ ;
               "Error: "     + Transform(oError:GenCode,   nil) + ";" +CRLF+ ;
               "SubC: "      + Transform(oError:SubCode,   nil) + ";" +CRLF+ ;
               "OSCode: "    + Transform(oError:OsCode,    nil) + ";" +CRLF+ ;
               "SubSystem: " + Transform(oError:SubSystem, nil) + ";" +CRLF+ ;
               "Mensajem: "  + oError:Description, "Ateno " )

   END

   //--> FIM DAS CONFIGURACOES.
   IF lRet

      TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

      IF LEN( aAttach ) >= 1 // ? [TEM ANEXO]

         MsgRun( "Tentando Enviar o Email com Anexo(s) ", ;
                 "Favor Esperar, Pode Demorar!         ", ;
                 { || lRet := Envia_Mail(oCfg,cRemt,cDest, cCC, cCCO, cTxt, cSubject) } )
         
      ELSE // ? [NAO TEM AXEXO]

         // Era assim
         //lRet := Envia_Mail(oCfg,cRemt,cDest, cCC, cCCO, cTxt, cSubject)
         MsgRun( "Tentando Enviar o Email sem Anexo(s) ", ;
                 "Favor Esperar, Pode Demorar!         ", ;
                 { || lRet := Envia_Mail(oCfg,cRemt,cDest, cCC, cCCO, cTxt, cSubject) } )
         
      ENDIF

   ENDIF
   
RETURN( lRet )
 
********************************************************************************
FUNCTION Envia_Mail( oCfg,cFROM, cTo, cCC, cBCC, cMsg, cSubject )
 
  LOCAL cToken
  LOCAL lRet := .F.
  
  cTo   := Destinatarios( cTo )  //-> PARA
  cCC   := Destinatarios( cCC )  //-> COM COPIA
  cBCC  := Destinatarios( cBCC ) //-> COM COPIA OCULTA
 	
  TRY
     oMsg := CREATEOBJECT ( "CDO.Message" )

     WITH OBJECT oMsg

          :Configuration = oCfg
          :FROM = cFROM
          :To = cTo
          :CC = cCC
          :BCC = cBCC
				
          :Subject = cSubject
          :TextBody = cMsg

          FOR x := 1 To Len( aAttach )  // Anexos dos Email aqui

             IF aAttach[x] <> NIL
                :AddAttachment(ALLTRIM(aAttach[x]))
             ENDIF

          NEXT

          :Send()

     END WITH

     lRet := .T.

   CATCH

      MsgInfo( "No Foi Possvel Enviar a Mensagem " +CRLF+ ;
               "Verifique o Remetente              " +CRLF+ ;
               "Verifique o Destinatrio           ",       ;
               "Ateno " )

      lRet := .F.

   END

   TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )
    
RETURN( lRet )

//------------------------------------------------------------
FUNCTION Destinatarios( cVar )

   LOCAL I, X,cGrupo, nCod
   LOCAL aCars := {",", "/", "\", ";"}
   LOCAL cLista := ""
   LOCAL lSalva := .T., lAll := .F.

   PRIVATE aTp := {}

   FOR I := 1 TO LEN( aCars )
      cVar := StrTran( cVar, aCars[i], CRLF )
   NEXT

   FOR I := 1 TO MLCount( cVar, 250 )
      AADD(aTp, ALLTRIM(MemoLine(cVar, 250, i)))
   NEXT

   FOR I := 1 TO LEN( aTp )

     cTemp :=  aTp[i]

     IF LEFT(cTemp, 2) = "<<" .AND. RIGHT(cTemp, 2) = ">>"

        cGrupo := StrTran(cTemp, "<<", "")
        cGrupo := StrTran(cGrupo, ">>", "")
        cGrupo := cGrupo+SPACE(20-LEN(cGrupo))

        IF !oCab:Seek(cGrupo)

           Msginfo( 'Grupo "'+ALLTRIM(cGrupo)+'" No Encontrado' )

        ELSE

           oGru:Gotop()

           WHILE !oGru:Eof()

              SysRefresh()

              oGru:Load()
              cLista += ";"+NomeCont(oGru:CodC)
              oGru:Skip()

           ENDDO

        ENDIF

     ELSE

        // cLista, e a Qtde de Emails do Campo PARA: Destinatario(s) do Email
        cLista += ";"+cTemp

        //? [clista, quem e? ], cLista
		
        IF lCheck

           IF !oCon:Seek(cTemp+SPACE(100-Len(cTemp)))

              oCon:Blank()
              oCon:Contato := cTemp
              oCod:Load()

              nCod := oCod:CodC+1
              oCod:CodC := nCod

              oCod:Save()

              oCon:CodC := nCod

              oCon:Append()
              oCon:Save()

           ENDIF

        ENDIF

     ENDIF

   NEXT

RETURN( cLista )
 
//----------------------------------------------------------------
FUNCTION ADDItem()

   LOCAL cArq := cGetFile32("*.*", "Adicionar(Inserir) Anexo ", , ,.F.)
 
   IF FILE( cArq ) // adiciona anexo e liga a listbox

      oList:ADD(ALLTRIM(cArq))
      oList:Hide()
      oList:Refresh()
      oList:Show()

   ENDIF
 
RETURN NIL
 
//---------Nao funcionava corretamente----------------------------
/* // Funcao Inutil, Nao funcionava direito de jeito nenhum
FUNCTION DELItem() // Exclusao do Anexo - Coloquei direto no botao

   LOCAL nIT := oList:GetSel()

   oList:DEL( nIT )
   oList:Hide()
   oList:Refresh()
   oList:Show()

RETURN NIL
*/
 
//----------------------------------------------------------
FUNCTION ArqsDBF()  // CRIA OS ARQUIVOS.DBF
 
   LOCAL aEstG, aEstR, aEstC, aEstCods, aEstEnvia

   aEstCods := { { "CODG", "N", 10, 0 },;
                 { "CODC", "N", 10, 0 } }
	
   aEstG := { { "CODG",   "N", 10, 0 },;
              { "GRUPO",  "C", 20, 0 } }
				
   aEstR := { { "CODG",   "N", 10, 0 },;
              { "CODC",   "N", 10, 0 } }
				
   aEstC := { { "CODC",     "N", 10, 0 },;
              { "CONTATO",  "C", 100, 0 } }

   aEstEnvia := { { "CODC",     "N", 10, 0 },;
                  { "CONTATO",  "C", 100, 0 } }

   //-----------------------------------------------------------------------//

   // Criacao dos bancos de dados
   IF .NOT. FILE( "SERVIDOR.DBF" ) 

      DbCreate( "SERVIDOR.DBF", { { "SEMAILPOP3", "C", 40, 00 }, ;
                                  { "SEMAILSMTP", "C", 40, 00 }, ;
                                  { "SEMAILCONT", "C", 40, 00 }, ;
                                  { "NPORTASERV", "N", 03, 00 }, ;
                                  { "CONEXAOSEG", "L", 01, 00 }, ;
                                  { "NOMEDOUSUA", "C", 40, 00 }, ;
                                  { "SENHACONTA", "C", 40, 00 } } )

   ENDIF
	
   If !File( "Codigos.dbf")
      DBCreate( "Codigos.dbf", aEstCods )
   endif
	
   If !File( "CabGrupo.dbf")
      DBCreate( "CabGrupo.dbf", aEstG )
   endif
	
   If !File( "Grupos.dbf")
      DBCreate( "Grupos.dbf", aEstR )
   endif
	
   If !File( "Contatos.dbf")
      DBCreate( "Contatos.dbf", aEstC )
   endif

   // Emails Para Enviar
   If !File( "EMAILENV.dbf")
      DBCreate( "EMAILENV.dbf", aEstEnvia )
   endif

   /*
   FIELD SEMAILPOP3, SEMAILSMTP, SEMAILCONT, NPORTASERV, CONEXAOSEG,  ;
         NOMEDOUSUA, SENHACONTA
   */

   USE SERVIDOR NEW
   INDEX ON SERVIDOR->SEMAILPOP3 TO SERVPOP3
   INDEX ON SERVIDOR->SEMAILSMTP TO SERVSMTP
   INDEX ON SERVIDOR->NOMEDOUSUA TO NOMEUSUA
   SET INDEX TO SERVPOP3, SERVSMTP, NOMEUSUA
   DATABASE DbServidor
	
   Use Codigos New
   DATABASE oCod
	
   Use CabGrupo New
   INDEX on CabGrupo->Grupo to GCabGru
   DATABASE oCab
	
   Use Grupos New
   Set Filter to Grupos->CodG = CabGrupo->CodG
   DATABASE oGru

   Use Contatos New
   INDEX on Contatos->CodC to CodCont
   INDEX on Contatos->Contato to cCont
   SET INDEX TO cCont, CodCont

   DATABASE oCon  // Lista de contatos
	
   IF oCod:RecCount() = 0
      oCod:Append()
      oCod:Save()
   ENDIF

   DbServidor:bBoF   := NIL ; DbServidor:bEoF   := NIL
   oCab:bBoF   := NIL ; oCab:bEoF   := NIL
   oGru:bBoF   := NIL ; oGru:bEoF   := NIL
   oCon:bBoF   := NIL ; oCon:bEoF   := NIL
   oCod:bBoF   := NIL ; oCod:bEoF   := NIL
	
RETURN NIL

//-----------------------------------------------------------------
 // Esta funcao CRIA uma BitMap, Nao usei. Peguei do EMAIL.RES
Static FUNCTION ArqBmp()

   LOCAL cHexa

   IF FILE("_loc.bmp") // Peguei direto do arquivo de recursos EMAIL.RES
      RETURN NIL
   ENDIF

   cHexa := "424df6000000000000003600000028000000080000000800000001001800"
   cHexa += "00000000c0000000c30e0000c30e00000000000000000000ffffffffffff"
   cHexa += "fffffffffffffffffff6f7fae9edf4ffffffffffffffffffffffffffffff"
   cHexa += "f4f6fa9bb9d7749fc8d7e1edffffffebf2f7b7cfe4b1c9e18ab2d386bfdb"
   cHexa += "71a4cacdd6e5ebf3f8a3c6ddc1d3e2dbe3e9abc9dd6fa6cec1d3e7ffffff"
   cHexa += "c6deecbad4e2fff9effff7edfcf7f09ab8d5e5edf5ffffffc4ddedc7dce6"
   cHexa += "fff6ebfbf2e9fff7efaec8dde4edf5ffffffdeedf5a9cee2e7ebeaf5f1eb"
   cHexa += "d8e2e89ec0dbf1f6faffffffffffffd6e8f2acd0e4b5d4e6aacde2e2edf5"
   cHexa += "ffffffffffff"

   MemoWrit( "_loc.bmp", _Binario(cHexa) )

RETURN NIL

//---------------------------------------------------------------------------

FUNCTION _Binario( cHexa )

   LOCAL i, nInd1, nInd2, nByte, cBin := ""
   LOCAL aBase := {"0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"}

   FOR i := 1 to len( cHexa ) STEP 2
     
      nInd1 := aScan(aBase, SubStr( cHexa, i, 1 ))-1
      nInd2 := aScan(aBase, SubStr( cHexa, i+1, 1 ))-1
      nByte := nInd1*16+nInd2
      cBin += Chr(nByte)
	
   NEXT

   RETURN cBin

RETURN cHexa

//-----------------------------------------------------------------------
FUNCTION Contatos() // Cadastro de Emails

   PRIVATE oBrw1, oBut1, oBut2, oBut3, oBrw2,;
           oBut4, oBut5, oBrw3, oBut6, oBut7,;
           oBut8, lInicio := .F., oFontCont, oBrush

   // Banco Onde ficam armazenados os emails
   SELECT CONTATOS
   SET INDEX TO cCont, CodCont

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE DIALOG oDlgCont TITLE "Gerenciar Contatos(Emails) " ;
          FROM 0, 0 to 484, 791 PIXEL                         ;
          COLOR 0, 15790320 BRUSH oBrush TRANSPARENT

   oDlgCont:lHelpIcon := .F.

   oDlgCont:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                             + CRLF+ ;
                                                 "No Est Ativo" ), ;
                                    ( OemToAnsi( "Informao   " ) ) ) }

   ACTIVATE DIALOG oDlgCont CENTERED ;
            ON INIT( Ini_oDlgCont() )

   oBrush:End()

RETURN NIL

//--------------------"Gerenciar Contatos"-----------------------------------

FUNCTION Ini_oDlgCont() // "Gerenciar Contatos"

   LOCAL oSay1, oSay2, oSay3, oSay4

   oGru:Load()

   // Se Grupos.Dbf estiver vazio...
   IF oGru:Eof()
      lRemoveGru := .F.  // Desliga o botao de Exclusao do Grupo
   ENDIF

   // ListBox
   @  11,  14 LISTBOX oBrw1                   ;
              FIELDS CONTATOS->CONTATO        ;
              HEADERS "CONTATOS"              ;
              SIZE 406, 409 PIXEL OF oDlgCont ;
              FONT oFont1                     ;
              ALIAS "CONTATOS"                ;
              ON DBLCLICK( lRemoveGru := .T., ADDCont() )

   //-> Disparos Automaticos na ListBox
   oBrw1:bKeyDown := { | nKey | IF ( nKey = VK_RETURN,                   ;
                                   ( ( lRemoveGru := .T., ADDCont() ) ), ;
                                IF ( nKey = VK_INSERT,                   ;
                                   ( "" ),                               ;
                                IF ( nKey = VK_DELETE,                   ;
                                   ( "" ), ) ) ) }

   oBrw1:nClrText := {|| IIF( OrdKeyNo()%2=0,          0,          0 ) }
   oBrw1:nClrPane := {|| IIF( OrdKeyNo()%2=0,   15790320,   16777215 ) }
   oBrw1:nClrForeHead  :=   16777215
   oBrw1:nClrBackHead  :=    8421504
   oBrw1:nClrForeFocus :=   16777215
   oBrw1:nClrBackFocus :=    8388608

   // Botoes

   @ 444,  14 BUTTON oBut1 PROMPT "&Incluir "    SIZE  75, 24 PIXEL ;
              OF oDlgCont                                           ;
              ACTION( CadContato(.T.) ) FONT oFont1

   oBut1:cToolTip := OemToAnsi( "Cadastrar Novo Contato(Email) " )

   @ 444,  93 BUTTON oBut2 PROMPT "&Alterar " SIZE  75, 24 PIXEL ;
              OF oDlgCont                                        ;
              ACTION( CadContato( .F. ) ) FONT oFont1

   oBut2:cToolTip := OemToAnsi( "Alterar o Contato(Email) " )

   @ 444, 172 BUTTON oBut3 PROMPT "&Excluir " SIZE  75, 24 PIXEL ;
              OF oDlgCont                                        ;
              ACTION( DeleteCon() ) FONT oFont1

   oBut3:cToolTip := OemToAnsi( "Excluir o Contato(Email) " )

   @  11, 444 LISTBOX oBrw2                    ;
               FIELDS CABGRUPO->GRUPO          ;
               HEADERS "GRUPOS "               ;
               SIZE 300, 171 PIXEL OF oDlgCont ;
               FONT oFont1                     ;
               ALIAS "CABGRUPO"                ;
               ON CHANGE IF( lInicio, ( oBrw3:Hide(), oBrw3:GoTop(), ;
                                        oBrw3:Refresh(), oBrw3:Show()), NIL )
	  

   oBrw2:nClrText := {|| IIF( OrdKeyNo()%2=0,          0,          0 ) }
   oBrw2:nClrPane := {|| IIF( OrdKeyNo()%2=0,   15790320,   16777215 ) }
   oBrw2:nClrForeHead  :=   16777215
   oBrw2:nClrBackHead  :=    8421504
   oBrw2:nClrForeFocus :=   16777215
   oBrw2:nClrBackFocus :=    8388608

   // Botoes

   @  26, 746 BUTTON oBut4 PROMPT "No&vo " SIZE  44, 26 PIXEL ;
              OF oDlgCont                                     ;
              ACTION( CadastraGru( .T. ) ) FONT oFont1

   oBut4:cToolTip := OemToAnsi( "Novo Grupo de Email" )

   @  56, 746 BUTTON oBut5 PROMPT "Al&t " SIZE  44, 26 PIXEL ;
              OF oDlgCont                                    ;
              ACTION( CadastraGru( .F. ) ) FONT oFont1

   oBut5:cToolTip := OemToAnsi( "Alterar Grupo " )
			  
   @  86, 746 BUTTON oBut5a PROMPT "&Del " SIZE  44, 26 PIXEL ;
              OF oDlgCont                                     ;
              ACTION( DeletaGru() ) FONT oFont1

   oBut5a:cToolTip := OemToAnsi( "Deletra(Apagar) Grupo " )

   @ 186, 444 LISTBOX oBrw3;
              FIELDS NomeCont(GRUPOS->CODC)   ;
              HEADERS "INTEGRANTES DO GRUPO"  ;
              SIZE 300, 234 PIXEL OF oDlgCont ;
              FONT oFont1 ALIAS "GRUPOS"

   oBrw3:nClrText := {|| IIF( OrdKeyNo()%2=0,          0,          0 ) }
   oBrw3:nClrPane := {|| IIF( OrdKeyNo()%2=0,   15790320,   16777215 ) }
   oBrw3:nClrForeHead  :=   16777215
   oBrw3:nClrBackHead  :=    8421504
   oBrw3:nClrForeFocus :=   16777215
   oBrw3:nClrBackFocus :=    8388608

   // Say
   @ 424, 14 SAY oSay1 PROMPT( OemToAnsi( "Relao de Contatos(Emails) " + ;
                                          "Cadastrados no Sistema " ) )    ;
             SIZE 400, 12 OF oDlgCont                                      ;
             PIXEL FONT oFont1 COLOR 0, 15790320

   @ 424, 422 SAY oSay2 PROMPT( OemToAnsi( "<Click> no Email ao Lado e " +;
                                           "<Click> na Seta Para Direita" ) );
              SIZE 400, 12 OF oDlgCont                                     ;
              PIXEL FONT oFont1 COLOR 0, 15790320


   @ 438, 422 SAY oSay3 PROMPT( OemToAnsi( "<Click> na Seta Para Esquerda "+;
                                           "Para Remover do Grupo" ) )      ;
              SIZE 400, 12 OF oDlgCont                                       ;
              PIXEL FONT oFont1 COLOR 0, 15790320

   @ 452, 429 SAY oSay4 PROMPT( OemToAnsi( "Escolha um Email Antes  "+;
                                           "Para Remover do Grupo" ) )      ;
              SIZE 400, 12 OF oDlgCont                                       ;
              PIXEL FONT oFont1 COLOR 0, 15790320

   // Botoes

   /* // era assim
   @ 268, 422 BUTTON oBut6 PROMPT ">" SIZE  21,  21 PIXEL ;
              OF oDlgCont ACTION ADDCont() FONT oFont1
   */
   @ 190, 422 BTNBMP oBut6 RESOURCE "DESPUES2"       ;
              SIZE  21,  21 PIXEL                    ;
              OF oDlgCont                            ;
              ACTION( lRemoveGru := .T., ADDCont() ) ;
              FONT oFont1 // esta na linha +-1163

   oBut6:cToolTip := OemToAnsi( "Adicionar Contato   Grupo de Integrantes " )

   /* // era assim
   @ 290, 422 BUTTON oBut7 PROMPT "<" SIZE  21,  21 PIXEL ;
              OF oDlgCont ACTION RemoveCont() FONT oFont1
   */
   @ 212, 422 BTNBMP oBut7 RESOURCE "ANTES2"         ;
              SIZE  21,  21 PIXEL                    ;
              OF oDlgCont                            ;
              WHEN( lRemoveGru )                     ;
              ACTION( RemoveCont( oBut7 ) )          ;
              FONT oFont1

   oBut7:cToolTip := OemToAnsi( "Deletar(Apagar) Contato " + ;
                                "Grupo de Integrantes " )

   //444, 675 // ERA ASSIM
   @ 444, 252 BUTTON oBut8 PROMPT "&Saida " SIZE  70,  24 PIXEL ;
              OF oDlgCont                                       ;
              ACTION( oDlgCont:End() ) FONT oFont1              ;
              CANCEL UPDATE

   oBut8:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   lInicio := .T.

   // Reacao na ListBox do Contatos
   oBrw3:Hide(); oBrw3:GoTop(); oBrw3:Refresh(); oBrw3:Show()
			  
RETURN NIL

//------------------------------------------------------------
FUNCTION ADDCont()  // Adicionar um contato ou grupo

   oCab:Load()

   IF oCab:CodG = 0

      MsgInfo( "Selecione um GRUPO ", "Ateno " )

      RETURN NIL

   ENDIF

   oCon:Load()

   IF oCon:CodC = 0

      MsgInfo( "Selecione um Contato ", "Ateno " )

      RETURN NIL

   ENDIF

   // o Alias,  CONTATOS.DBF

   oGru:Blank()
   oGru:CodC := oCon:CodC
   oGru:CodG := oCab:CodG
   oGru:Append()
   oGru:Save()

   oBrw3:Hide()
   oBrw3:GoTop()
   oBrw3:Refresh()
   oBrw3:GoBottom()
   oBrw3:SetFocus()
   oBrw3:Show()

RETURN NIL

//-------------------------------------------------------------
FUNCTION RemoveCont( oBut7 )

   oGru:Load()

   TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

   IF MsgNoYes( 'Remover o Contato Selecionado? ', "Ateno " )

      oGru:Delete()

      oBrw3:Hide()
      oBrw3:GoTop()
      oBrw3:Refresh()
      oBrw3:GoBottom()
      oBrw3:SetFocus()
      oBrw3:Show()

   ENDIF

   // Se Grupos.Dbf estiver vazio...
   IF oGru:Eof()
      lRemoveGru := .F.  // Desliga o botao de Exclusao do Grupo
      oBut7:Disable()
      oBut7:Refresh()
   ENDIF

RETURN NIL

//----------------------------------------------------------------
FUNCTION CadContato( lNovo )

   LOCAL oFnt, oFont, oGravar, oSaida, oBrush

   PRIVATE oDlgCadCon

   IF lNovo
     oCon:Blank()
   ELSE
      oCon:Load()
   ENDIF

   // Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFont NAME GetSysFont()    SIZE 0, -12 BOLD
   DEFINE FONT oFnt  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgCadCon ;
          TITLE IF(lNovo, "Novo Contato ", "Alterando Email " ) ;
          FROM 0,0 TO 200,300 PIXEL BRUSH oBrush TRANSPARENT

   oDlgCadCon:lHelpIcon := .F.

   oDlgCadCon:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                               + CRLF+ ;
                                                   "No Est Ativo" ), ;
                                      ( OemToAnsi( "Informao   " ) ) ) }

   // era assim
   //@ 20,20 Say "Contato" SIZE 40,10 PIXEL FONT oFont COLOR CLR_BLACK
   @ 20,20 SAY IF(lNovo, "Novo Email: ", 'Alterando: '+oCon:Contato ) ;
           SIZE 200, 10 PIXEL FONT oFont COLOR CLR_BLACK

   @ 32,20 Get oGetCon Var oCon:Contato SIZE 110,10 PIXEL FONT oFont ;
           COLOR CLR_BLACK, CLR_WHITE
			
   @ 70, 25 BUTTON oGravar PROMPT( "&Gravar " ) ;
            SIZE 40,10 PIXEL                    ;
            ACTION SalvaCon( lNovo )

   oGravar:cToolTip := OemToAnsi( "Gravar Contato(Email) " )

   @ 70, 85 BUTTON oSaida PROMPT( "&Saida  " ) ;
            SIZE 40,10 PIXEL                   ;
            ACTION( oDlgCadCon:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oGravar     TO oFont
   SET FONT OF oSaida      TO oFont
			
   ACTIVATE DIALOG oDlgCadCon CENTERED

   oBrush:End()
   oFnt:End()
   oFont:End()

RETURN NIL

//----------------------------------------------------------------
FUNCTION SalvaCon( lNovo )

   LOCAL nCod

   IF lNovo

      oCod:Load()
      nCod := oCod:CodC+1
      oCod:CodC := nCod
      oCod:Save()
      oCon:CodC := nCod
      oCon:Append()

   ENDIF

   oCon:Contato := LOWER( oCon:Contato )
   oCon:Save()

   oBrw1:Hide()
   oBrw1:Refresh()
   oBrw1:Show()

   oDlgCadCon:End()

RETURN NIL

//----------------------------------------------------------------
FUNCTION DeleteCon()

   oCon:Load()

   IF MsgNoYes( 'Excluir o Contato "'+ALLTRIM(oCon:Contato)+'"?', "Ateno")

      oCon:Delete()
      oBrw1:Hide()
      oBrw1:Refresh()
      oBrw1:Show()

   ENDIF

RETURN NIL

//------------------------------------------------------------
FUNCTION CadastraGru( lNovo )

   LOCAL oFnt, oFont, oGravar, oSaida, oBrush

   PRIVATE oDlgCadGru

   IF lNovo // e uma inclusao de grupo
      oCab:Blank()
   ELSE     // alteracao do grupo
      oCab:Load()
   ENDIF

   // Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFont NAME GetSysFont()    SIZE 0, -12 BOLD
   DEFINE FONT oFnt  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgCadGru                                           ;
          TITLE IF(lNovo, "Novo Grupo", 'Alterando "'+oCab:Grupo+'"') ;
          FROM 0,0 to 200,300 PIXEL BRUSH oBrush TRANSPARENT

   oDlgCadGru:lHelpIcon := .F.

   oDlgCadGru:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                               + CRLF+ ;
                                                   "No Est Ativo" ), ;
                                      ( OemToAnsi( "Informao   " ) ) ) }
				
   @ 20,20 Say "GRUPO" SIZE 40,10 PIXEL

   @ 32,20 Get oGetGru Var oCab:Grupo SIZE 110,10 PIXEL
			
   @ 70, 25 BUTTON oGravar PROMPT( "&Gravar " ) ;
            SIZE 40,10 PIXEL                    ;
            ACTION( SALVAGRU( lNovo ) )  // Salvar o Grupo

   oGravar:cToolTip := OemToAnsi( "Gravar o Grupo " )

   @ 70, 85 BUTTON oSaida PROMPT( "&Saida  " ) ;
            SIZE 40,10 PIXEL                   ;
            ACTION( oDlgCadGru:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oGravar     TO oFont
   SET FONT OF oSaida      TO oFont
			
   ACTIVATE DIALOG oDlgCadGru CENTERED

   oBrush:End()
   oFnt:End()
   oFont:End()

RETURN NIL

//-------------------------------------------------------
FUNCTION SalvaGru( lNovo )  // Gravar o Grupo

   LOCAL nCod

   IF lNovo

      oCod:Load()
      nCod := oCod:CodG+1
      oCod:CodG := nCod
      oCod:Save()
      oCab:CodG := nCod
      oCab:Append()

   ENDIF
  
   oCab:Grupo := LOWER(oCab:Grupo)
   oCab:Save()
	
   oBrw2:Hide()
   oBrw2:Refresh()
   oBrw2:Show()

   oDlgCadGru:End()

RETURN NIL
//----------------------------------------------------------------
FUNCTION DeletaGru()  // Exclusao do Grupo

   oCab:Load()

   IF MsgNoYes( 'Excluir o Grupo "'+ALLTRIM(oCab:Grupo)+'"?', "Ateno")

      oCab:Delete()
      oBrw2:Hide()
      oBrw2:Refresh()
      oBrw2:Show()

   ENDIF

RETURN NIL

//-----------------------------------------------------------------
FUNCTION NomeCont( nCod )  // Pega o Email do Contato

   LOCAL nRec := oCon:RecNo()
   LOCAL cNome := ""

   SELECT Contatos
   SET INDEX TO CodCont, cCont

   IF oCon:Seek( nCod )
      cNome := oCon:Contato
   ENDIF

   //? cNome, [LINHA 1327 - NOME DO CONTATO]

   SELECT Contatos
   SET INDEX TO cCont, CodCont

   oCon:GoTo(nRec)

RETURN( cNome )

//---------------------------------------------------------------
FUNCTION Inclui( oGet, cVar ) // Inclusao do Contato/Grupo

   LOCAL oFnt, oFont, oConfirma, oSaida, oSay1, oSay2, oSay3, oBrush

   PRIVATE oDlgInc

   nRad := 1

   TONE( 900, 2) ; TONE( 900, 2 ) ; TONE( 1000, 2 )

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFont NAME GetSysFont()    SIZE 0, -12 BOLD
   DEFINE FONT oFnt  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgInc TITLE "Incluir Contato / Grupo " ;
          FROM 0,0 to 200, 300 PIXEL BRUSH oBrush TRANSPARENT

   oDlgInc:lHelpIcon := .F.

   oDlgInc:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                            + CRLF+ ;
                                                "No Est Ativo" ), ;
                                   ( OemToAnsi( "Informao   " ) ) ) }

   // SAY do Radio

   @ 007, 25 SAY oSay1 PROMPT( OemToAnsi( "Escolha Uma Opo: " ) ) ;
             SIZE 150, 10 OF oDlgInc                                ;
             PIXEL FONT oFnt COLOR CLR_BLACK

   // Radio
   @ 20,20 RADIO oRad VAR nRad ;
           PROMPT "&Selecionar Contato(Email) ", "Incluir &Grupo do Email" ;
           SIZE 150, 10 PIXEL

   SET FONT OF oDlgInc  TO oFont

   @ 045, 25 SAY oSay2 PROMPT( OemToAnsi( "Voc Pode Selecionar Vrios " ) ) ;
             SIZE 150, 10 OF oDlgInc                                         ;
             PIXEL FONT oFnt COLOR CLR_BLACK

   @ 055, 25 SAY oSay3 PROMPT( OemToAnsi( "Contatos(Emails) Para Enviar." ) );
             SIZE 150, 10 OF oDlgInc                                         ;
             PIXEL FONT oFnt COLOR CLR_BLACK

   // Botoes

   @ 70, 25 BUTTON oConfirma PROMPT( "&Confirme " ) ;
            SIZE 40,10 PIXEL                        ;
            ACTION IncluiCont( nRad, oGet, @cVar )

   oConfirma:cToolTip := OemToAnsi( "Confirme a Incluso do Contato / Grupo " )

   @ 70, 85 BUTTON oSaida PROMPT( "&Saida " ) ;
            SIZE 40,10 PIXEL                  ;
            ACTION( oDlgInc:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oConfirma   TO oFont
   SET FONT OF oSaida      TO oFont
             
   ACTIVATE DIALOG oDlgInc CENTERED

   oBrush:End()
   oFnt:End()
   oFont:End()

RETURN NIL

//-----------------------------------------------------------
FUNCTION IncluiCont( nRad, oGet, cVar )

   IF nRad = 1
      BuscaCont(oGet, @cVar)
   ELSE
      BuscaGru(oGet, @cVar)
   ENDIF

RETURN NIL

//----------------------------------------------------------

FUNCTION BuscaCont( oGet, cVar )  // Busca o Contato

   LOCAL oFnt, oFont, oConfirma, oSaida, oBtnPegaEmail, oBtnExcluiEmail
   LOCAL oSay1, oSay2, oSay3, oSay4, oSay5, oSay6, cTitle, oBrush

   PRIVATE oDlgCon

   cTitle := [Relao de Contatos(Emails) ] + ;
             [Cadastrados no Sistema - ]    + ;
             [Escolha Para Quem Vai Enviar o Email]

   aListCont := {}
   nListCont := 1

   //?    cTitle

   // Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFont NAME GetSysFont()    SIZE 0, -12 BOLD
   DEFINE FONT oFnt  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgCon TITLE cTitle FROM 0,0 to 484, 792 PIXEL ;
          BRUSH oBrush TRANSPARENT

   oDlgCon:lHelpIcon := .F.

   oDlgCon:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                            + CRLF+ ;
                                                "No Est Ativo" ), ;
                                   ( OemToAnsi( "Informao   " ) ) ) }

   @ 3.50,14 SAY oSay1 PROMPT( OemToAnsi( "Relao de Contatos(Emails) " + ;
                                          "Cadastrados no Sistema " ) )    ;
             SIZE 200, 10 OF oDlgCon                                       ;
             PIXEL FONT oFont COLOR CLR_BLACK

   @ 3.50,232 SAY oSay1 PROMPT( OemToAnsi( "Grupo de Contatos(Emails) " + ;
                                           "Para Enviar " ) )             ;
              SIZE 150, 10 OF oDlgCon                                     ;
              PIXEL FONT oFont COLOR CLR_BLACK

   @ 210, 232 SAY oSay3 PROMPT( OemToAnsi( "<Click> no Email ao Lado e " +;
                                           "<Click> na Seta Para Direita" ) );
              SIZE 200, 10 OF oDlgCon                                     ;
              PIXEL FONT oFont COLOR CLR_BLACK

   @ 217, 232 SAY oSay4 PROMPT( OemToAnsi( "<Click> na Seta Para Esquerda "+;
                                           "Para Remover do Grupo" ) )      ;
              SIZE 200, 10 OF oDlgCon                                       ;
              PIXEL FONT oFont COLOR CLR_BLACK

   @ 217,  14 SAY oSay5 PROMPT( OemToAnsi( "Escolha um Email na ListBox " + ;
                                           "Acima e <Click> na Seta "     + ;
                                           "Para Direita " ) )              ;
              SIZE 200, 10 OF oDlgCon                                       ;
              PIXEL FONT oFont COLOR CLR_BLACK

   // ListBox da Relacao de Emails Cadastrados no Sistema
   @  11,  14 LISTBOX oBrw                   ;
              FIELDS CONTATOS->CONTATO       ;
              HEADERS "CONTATOS"             ;
              SIZE 203, 205 PIXEL OF oDlgCon ;
              FONT oFont1                    ;
              ALIAS "CONTATOS"               ;
              ON DBLCLICK( oCon:Load(), oListCont:ADD(oCon:Contato),            ;
                                   oListCont:GoTop(), oListCont:Refresh(), ;
                               oListCont:GoBottom(), oListCont:SetFocus(), ;
                                   lLigaBotao := .T.,                      ;
                            TONE( 900, 2), TONE( 900, 2 ), TONE( 1000, 2 ) )

   oBrw:cToolTip := OemToAnsi( "Use: <Enter> ou <Click> do Mouse" )

   //-> Disparos Automaticos na ListBox
   oBrw:bKeyDown := { | nKey | IF ( nKey = VK_RETURN,                      ;
                             ( ( oCon:Load(), oListCont:ADD(oCon:Contato), ;
                                   oListCont:GoTop(), oListCont:Refresh(), ;
                                   oListCont:GoBottom(),                   ;
                                   lLigaBotao := .T.,  XFOCUS( oBrw ),     ;
                      oBtnExcluiEmail:Enable(), oBtnExcluiEmail:Refresh(), ;
                      oConfirma:Enable(), oConfirma:Refresh(),             ;
                       TONE( 900, 2), TONE( 900, 2 ), TONE( 1000, 2 ) ) ), ;
                               IF ( nKey = VK_INSERT,                      ;
                                  ( "" ),                                  ;
                               IF ( nKey = VK_DELETE,                      ;
                                  ( "" ), ) ) ) }

   // Area dos SAYS

   /* // era assim
   @ 10,219 BUTTON ">" SIZE 10, 10 PIXEL ;
            ACTION( oCon:Load(), oListCont:ADD(oCon:Contato), ;
                                 oListCont:Refresh() )
   */
   // Voce Inclui Email Para Enviar
   @ 11,  217 BTNBMP oBtnPegaEmail RESOURCE "DESPUES2"                     ;
              SIZE  15,  15 PIXEL                                          ;
              ACTION( oCon:Load(), oListCont:ADD(oCon:Contato),            ;
                                   oListCont:GoTop(), oListCont:Refresh(), ;
                               oListCont:GoBottom(), oListCont:SetFocus(), ;
                                   lLigaBotao := .T.,                      ;
                      TONE( 900, 2),  TONE( 900, 2 ),  TONE( 1000, 2 ) )

   oBtnPegaEmail:cToolTip := OemToAnsi( "<Click-me> Para Adicionar " + ;
                                        "o Email ao Grupo " )


   /*  // era assim - Botao da Exclusao do Email Para Enviar
   @ 21,219 BUTTON "<" SIZE 10, 10 PIXEL;
            ACTION (oListCont:Del(nListCont), oListCont:Refresh())
   */
   @ 26,  217 BTNBMP oBtnExcluiEmail RESOURCE "ANTES2"                 ;
              SIZE  15,  15 PIXEL                                      ;
              WHEN( lLigaBotao )                                       ;
              ACTION( oListCont:Del( nListCont ), oListCont:Refresh(), ;
                      IF( LEN( aListCont ) > 0, lLigaBotao := .T.,     ; // Liga/Desliga o Botao
                                                lLigaBotao := .F. ),   ;
          oListCont:GoTop(), oListCont:Refresh(),oListCont:GoBottom(), ;
                     TONE( 900, 2),  TONE( 900, 2 ),  TONE( 1000, 2 ), ;
                 oBtnExcluiEmail:Disable(), oBtnExcluiEmail:Refresh(), ; // Desliga o Botao
                      oConfirma:Disable(), oConfirma:Refresh(),        ; // Desliga o Botao
                      IF( LEN( aListCont ) <= 0,                       ;
                          MsgInfo( "Voc No Selecionou Nenhum Email "+;
                                   "Para Enviar. "+CRLF+               ;
                                   "Ser Preciso Digitar o Email no "+ ;
                                   "Campo Para:  "+CRLF+               ;
                                   "Destinatrio do Email, ou Pegue "+ ;
                                   "um da Lista "+CRLF+                ;
                                   "de Contatos, Por Favor.",          ;
                                   "Ateno " ), .T. ), XFOCUS( oSaida ) )

   oBtnExcluiEmail:cToolTip := OemToAnsi( "<Click-me> Para Excluir " + ;
                                          "o Email do Grupo " )

   // ListBox do Grupo de Emails a Enviar
   @  11, 232 ListBox oListCont Var nListCont Items aListCont ;
              SIZE 150, 206 PIXEL OF oDlgCon Font oFont1

   oListCont:cToolTip := OemToAnsi( "Use: <Delete> " )

   //-> Disparos Automaticos na ListBox
   oListCont:bKeyDown := { | nKey | IF ( nKey = VK_RETURN,             ;
                                       ( "" ),                         ;
                                    IF ( nKey = VK_INSERT,             ;
                                       ( "" ),                         ;
                                    IF ( nKey = VK_DELETE,             ;
                                       ( APAGA_oListCont( oListCont,   ;
                                                          aListCont,   ;
                                                          nListCont,   ;
                         oBtnExcluiEmail, oConfirma, oSaida ) ), ) ) ) }

   //----------------------------------------------------------------------//                               

   // SAY da Saida
   @ 226,  14 SAY oSay6 PROMPT( OemToAnsi( "<ESC> Sair " ) )              ;
              SIZE 050, 10 OF oDlgCon                                     ;
              PIXEL FONT oFont COLOR CLR_BLACK

   // Botoes
			   
   @ 226, 148 BUTTON oConfirma PROMPT( "&Confirme" ) ;
              WHEN( lLigaBotao )                     ;
              SIZE 50, 10 PIXEL                      ;
              ACTION( CONFCONT( oGet, @cVar ) )

   oConfirma:cToolTip := OemToAnsi( "Confirme o Contato(Email) " + ;
                                    "Selecionado(s) " )

   @ 226, 200 BUTTON oSaida PROMPT( "&Saida " ) ;
              SIZE 40,10 PIXEL                  ;
              ACTION( oDlgCon:End() ) CANCEL UPDATE

   oSaida:cToolTip := OemToAnsi( "Saida - Exit - Cancelar " )

   SET FONT OF oConfirma   TO oFont
   SET FONT OF oSaida      TO oFont
			   
   ACTIVATE DIALOG oDlgCon CENTERED ;
            ON INIT( oBrw:GoBottom(), oBrw:Refresh(), oBrw:GoTop(), ;
                     oBrw:SetFocus() )

   oBrush:End()
   oFnt:End()
   oFont:End()

   lLigaBotao := .F.

RETURN NIL

// Apaga Email do Grupo de Emails a Enviar com a tecla <DELETE>

STATIC FUNCTION APAGA_oListCont( oListCont, aListCont, nListCont, ;
                                 oBtnExcluiEmail, oConfirma, oSaida )

   IF LEN( aListCont ) > 0

      oListCont:Del( nListCont )

      oListCont:GoTop()
      oListCont:Refresh()
      oListCont:GoBottom()

      TONE( 900, 2) ;  TONE( 900, 2 ) ;  TONE( 1000, 2 )

   ENDIF

   IF LEN( aListCont ) <= 0

      lLigaBotao := .F.

      oBtnExcluiEmail:Disable()
      oBtnExcluiEmail:Refresh()

      oConfirma:Disable()
      oConfirma:Refresh()

      XFOCUS( oSaida )

   ENDIF

RETURN NIL

FUNCTION ConfCont( oGet, cVar )  // Confirma o Contato

   LOCAL i

   oCon:Load()
	
   cVar := ALLTRIM(cVar)

   IF LEN(cVar) > 0
      cVar := ALLTRIM(cVar)+";"
   ENDIF
	
   FOR i := 1 TO LEN( aListCont )
      cVar := cVar+if(i>1,";", "")+ALLTRIM(aListCont[i])
   NEXT

   cVar+=SPACE(100)

   oGet:SetText( cVar )

   oDlgCon:End()
   oDlgInc:end()
	
RETURN NIL

//----------------------------------------------------------

FUNCTION BuscaGru( oGet, cVar )

   LOCAL oFnt, oFont, oConfirma, oSaida, oBrush

   PRIVATE oDlgGru

   // Dialogo

   DEFINE BRUSH oBrush  COLOR 14671839  // gris claro

   DEFINE FONT oFont NAME GetSysFont()    SIZE 0, -12 BOLD
   DEFINE FONT oFnt  NAME "Ms Sans Serif" SIZE 0, -14 BOLD //UnderLine

   DEFINE DIALOG oDlgGru TITLE "Grupos " FROM 0,0 TO 484, 450 PIXEL ;
          BRUSH oBrush TRANSPARENT

   oDlgGru:lHelpIcon := .F.

   oDlgGru:bRClicked = { || MsgInfo( OemToAnsi( "Boto Direito "    ;
                                                            + CRLF+ ;
                                                "No Est Ativo" ), ;
                                   ( OemToAnsi( "Informao   " ) ) ) }
	   
   @  11,  14 LISTBOX oBrw                   ;
              FIELDS CABGRUPO->GRUPO         ;
              HEADERS "GRUPOS"               ;
              SIZE 203, 205 PIXEL OF oDlgGru ;
              FONT oFont1                    ;
              ALIAS "CABGRUPO"

   // Botoes
			   
   @ 226, 071 BUTTON oConfirma PROMPT( "&Confirme " ) ;
              SIZE 40,10 PIXEL                        ;
              ACTION( ConfGru( oGet, @cVar ) )

   @ 226, 131 BUTTON oSaida PROMPT( "&Saida " ) ;
              SIZE 40,10 PIXEL                  ;
              ACTION( oDlgGru:End() ) CANCEL UPDATE

   SET FONT OF oConfirma   TO oFont
   SET FONT OF oSaida      TO oFont
			   
   ACTIVATE DIALOG oDlgGru CENTER

   oBrush:End()
   oFnt:End()
   oFont:End()

RETURN NIL

//-----------------------------------------------------------
FUNCTION ConfGru( oGet, cVar )

   oCab:Load()
	
   IF len(ALLTRIM(cVar)) > 0
      cVar := ALLTRIM(cVar)+";"
   ENDIF

   cVar := ALLTRIM(cVar)+"<<"+ALLTRIM(oCab:Grupo)+">>"+SPACE(100)

   oGet:SetText( cVar )

   oDlgGru:End()
   oDlgInc:End()
	
RETURN NIL

//-------------------------------------------------------------------------//
// As vezes simples SetFocus( oObj ) nao faz um objeto ganhar foco
// neste caso pode apelar para estas duas funcoes a seguir
// Forar foco para um objeto especifico - Ednaldo Rolim...
//-------------------------------------------------------------------------//
FUNCTION xSetFocus( oObj )

    LOCAL _oWnd := oObj:oWnd, _oTempo := ""

    DEFINE Timer _oTempo Interval 10 of _oWnd ;
           Action ( oObj:SetFocus(), _oTempo:End() )
    ACTIVATE Timer _oTempo

RETURN( .T. )

//-------------------------------------------------------------------------//
FUNCTION xFocus( oObj )

    xSetFocus( oObj )
    xSetFocus( oObj )

RETURN( .T. )

//-> Impresso dos Dados do Programa                  

STATIC FUNCTION IMPRIMESER( oLbxServ )

   LOCAL oPen1, oPen2           
   LOCAL oFont1, oFont2, oFont3 
   LOCAL oReport                
   LOCAL nRegistro := RecNo()   

   // Gera o Preview

   DEFINE PEN oPen1 WIDTH 2     
   DEFINE PEN oPen2 WIDTH 1     

   DEFINE FONT oFont1 NAME "Arial"       SIZE 0, -11
   DEFINE FONT oFont2 NAME "Arial"       SIZE 0, -11
   DEFINE FONT oFont3 NAME "Courier New" SIZE 0,  10 // Para Imprimir MEMOS

   SELECT( SER ) //-> Carrega o Banco: SERVIDOR.DBF
   DbGoTop()

   // PrnSetSize( 2160, 2480 ) //ancho,alto
   // PrnSetSize( 2160, 2790 ) //ancho,alto

   //PrinterSetup(oReport)  // Para escolher uma impressora ou pegar a padrao

   //PRINT oPrn NAME "Cdiario" PREVIEW
   /* // Exemplo, usando a PRINTER
   PrinterSetup(oPrn)

   PRINT oPrn NAME "Cdiario" PREVIEW

   While Empty( oPrn:hDC )
      MsgStop( "Impresora no esta lista!","Alto" )
   Enddo
   */

   PrnLandScape() // Horizontal
   //PrnPortrait() // Vertical

   REPORT oReport TITLE "Listagem dos SERVIDORES de Emails " ;
      CAPTION "Catlogo: SERVIDORES de Emails"               ;
      HEADER "SERVIDORES de Emails Cadastraddos ",           ;
      "Data:   " + DTOC( DATE() ),                           ;
      "Pgina: " + STR( oReport:nPage, 3 )                   ;
      FOOTER "- SERVIDORES -" CENTER                         ;
      FONT oFont1, oFont2, oFont3                            ;
      PEN oPen1, oPen2 ; //-> Tipo de linha a usar no cabealho 
      PREVIEW //-> Ativa o Preview - Listagem 

      //-> Para o Preview Maximizar e Nao Ficar no Rodape do Windows 
      oReport:oDevice:lPrvModal := .T. 
      oReport:oDevice:SetPage(9) //-> Formato A4

      COLUMN TITLE "Entrada POP3 " DATA ( SER )->SEMAILPOP3, ;
             +     "Email: "       +    ( SER )->SEMAILCONT, ;
             +     "Https: " +  IIF( ( SER )->CONEXAOSEG = .T., "Sim", "No") FONT 2

      COLUMN TITLE "Saida   SMTP " DATA ( SER )->SEMAILSMTP, ;
             +     "N. Porta: "   + STR(( SER )->NPORTASERV), ;
             +     "Usurio: "     + ( SER )->NOMEDOUSUA FONT 2

      // COLUMN TITLE "SENHACONTA " DATA ( SER )->SENHACONTA FONT 2

   END REPORT 

   IF !oReport:lCreated 
      RETURN NIL 
   ENDIF

   oReport:CellView() 

   ACTIVATE REPORT oReport ON INIT oReport:oTitle:aFont[1] := { || 3 }

   oPen1:End()  
   oPen2:End()  
   oFont1:End() 
   oFont2:End() 
   oFont3:End() 

   oLbxServ:GoTop()
   oLbxServ:Refresh()

   //-> DbGoTo( nRegistro ) 

RETURN NIL

//-> Aciona o Internet Explore e Entra na Pagina do Pleno

STATIC FUNCTION SITE_PLENOWIN()

   SYSWAIT(.5)

   MeuWinExec( "Start Iexplore.Exe http://www.pleno.com.br/", 0 )

   SYSWAIT(.5)

RETURN( .T. )

// Para Executar o OutLook Express Direto no Windows 2000 e XP e Demais Verses
/*
// IsWin2000()
// IsWinXP()
// IsNTPreWin2K()
// IsNTWorkstation()
// IsNTServer()
// IsWin2000Prof()
// IsWin2000Server()
*/
FUNCTION MeuWinExec( cParametro )

    //LOCAL cExec := GetPvProfString("Editor","Pgm","notepad", cIniFile )
    LOCAL cExecute := GetPvProfString( "" )

    // NT, 2000 e XP
    IF  IsWinNT() .OR. IsWin2000()
        cExecute := GetEnv( "COMSPEC" ) + " /C "
    ENDIF

RETURN WinExec( cExecute + cParametro, 0 )

// FIM DO PROGRAMA

